// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <p>Adds the specified tags to the specified load balancer. Each load balancer can have a maximum of 10 tags.</p>
/// <p>Each tag consists of a key and an optional value. If a tag with the same key is already associated
/// with the load balancer, <code>AddTags</code> updates its value.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/add-remove-tags.html">Tag Your Classic Load Balancer</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddTags {
    _private: (),
}
impl AddTags {
    /// Creates a new builder-style object to manufacture [`AddTagsInput`](crate::input::AddTagsInput)
    pub fn builder() -> crate::input::add_tags_input::Builder {
        crate::input::add_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddTags {
    type Output = std::result::Result<crate::output::AddTagsOutput, crate::error::AddTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_tags_error(response)
        } else {
            crate::operation_deser::parse_add_tags_response(response)
        }
    }
}

/// <p>Associates one or more security groups with your load balancer in a virtual private cloud (VPC). The specified security groups override the previously associated security groups.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-security-groups.html#elb-vpc-security-groups">Security Groups for Load Balancers in a VPC</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ApplySecurityGroupsToLoadBalancer {
    _private: (),
}
impl ApplySecurityGroupsToLoadBalancer {
    /// Creates a new builder-style object to manufacture [`ApplySecurityGroupsToLoadBalancerInput`](crate::input::ApplySecurityGroupsToLoadBalancerInput)
    pub fn builder() -> crate::input::apply_security_groups_to_load_balancer_input::Builder {
        crate::input::apply_security_groups_to_load_balancer_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ApplySecurityGroupsToLoadBalancer {
    type Output = std::result::Result<
        crate::output::ApplySecurityGroupsToLoadBalancerOutput,
        crate::error::ApplySecurityGroupsToLoadBalancerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_apply_security_groups_to_load_balancer_error(response)
        } else {
            crate::operation_deser::parse_apply_security_groups_to_load_balancer_response(response)
        }
    }
}

/// <p>Adds one or more subnets to the set of configured subnets for the specified load balancer.</p>  
/// <p>The load balancer evenly distributes requests across all registered subnets.
/// For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-manage-subnets.html">Add or Remove Subnets for Your Load Balancer in a VPC</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AttachLoadBalancerToSubnets {
    _private: (),
}
impl AttachLoadBalancerToSubnets {
    /// Creates a new builder-style object to manufacture [`AttachLoadBalancerToSubnetsInput`](crate::input::AttachLoadBalancerToSubnetsInput)
    pub fn builder() -> crate::input::attach_load_balancer_to_subnets_input::Builder {
        crate::input::attach_load_balancer_to_subnets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AttachLoadBalancerToSubnets {
    type Output = std::result::Result<
        crate::output::AttachLoadBalancerToSubnetsOutput,
        crate::error::AttachLoadBalancerToSubnetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_attach_load_balancer_to_subnets_error(response)
        } else {
            crate::operation_deser::parse_attach_load_balancer_to_subnets_response(response)
        }
    }
}

/// <p>Specifies the health check settings to use when evaluating the health state of your EC2 instances.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-healthchecks.html">Configure Health Checks for Your Load Balancer</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ConfigureHealthCheck {
    _private: (),
}
impl ConfigureHealthCheck {
    /// Creates a new builder-style object to manufacture [`ConfigureHealthCheckInput`](crate::input::ConfigureHealthCheckInput)
    pub fn builder() -> crate::input::configure_health_check_input::Builder {
        crate::input::configure_health_check_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ConfigureHealthCheck {
    type Output = std::result::Result<
        crate::output::ConfigureHealthCheckOutput,
        crate::error::ConfigureHealthCheckError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_configure_health_check_error(response)
        } else {
            crate::operation_deser::parse_configure_health_check_response(response)
        }
    }
}

/// <p>Generates a stickiness policy with sticky session lifetimes that follow that of an application-generated cookie. This policy can be associated only with HTTP/HTTPS listeners.</p>
/// <p>This policy is similar to the policy created by <a>CreateLBCookieStickinessPolicy</a>,
/// except that the lifetime of the special Elastic Load Balancing cookie, <code>AWSELB</code>,
/// follows the lifetime of the application-generated cookie specified in the policy configuration.
/// The load balancer only inserts a new stickiness cookie when the application response
/// includes a new application cookie.</p>
/// <p>If the application cookie is explicitly removed or expires, the session stops being sticky until a new application cookie is issued.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-sticky-sessions.html#enable-sticky-sessions-application">Application-Controlled Session Stickiness</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateAppCookieStickinessPolicy {
    _private: (),
}
impl CreateAppCookieStickinessPolicy {
    /// Creates a new builder-style object to manufacture [`CreateAppCookieStickinessPolicyInput`](crate::input::CreateAppCookieStickinessPolicyInput)
    pub fn builder() -> crate::input::create_app_cookie_stickiness_policy_input::Builder {
        crate::input::create_app_cookie_stickiness_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateAppCookieStickinessPolicy {
    type Output = std::result::Result<
        crate::output::CreateAppCookieStickinessPolicyOutput,
        crate::error::CreateAppCookieStickinessPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_app_cookie_stickiness_policy_error(response)
        } else {
            crate::operation_deser::parse_create_app_cookie_stickiness_policy_response(response)
        }
    }
}

/// <p>Generates a stickiness policy with sticky session lifetimes controlled by the lifetime of the browser (user-agent) or a specified expiration period. This policy can be associated only with HTTP/HTTPS listeners.</p>
/// <p>When a load balancer implements this policy, the load balancer uses a special cookie to track the instance for each request. When the load balancer receives a request, it first checks to see if this cookie is present in the request.
/// If so, the load balancer sends the request to the application server specified in the cookie. If not, the load balancer sends the request to a server that is chosen based on the existing load-balancing algorithm.</p>
/// <p>A cookie is inserted into the response for binding subsequent requests from the same user to that server. The validity of the cookie is based on the cookie expiration time, which is specified in the policy configuration.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-sticky-sessions.html#enable-sticky-sessions-duration">Duration-Based Session Stickiness</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateLBCookieStickinessPolicy {
    _private: (),
}
impl CreateLBCookieStickinessPolicy {
    /// Creates a new builder-style object to manufacture [`CreateLbCookieStickinessPolicyInput`](crate::input::CreateLbCookieStickinessPolicyInput)
    pub fn builder() -> crate::input::create_lb_cookie_stickiness_policy_input::Builder {
        crate::input::create_lb_cookie_stickiness_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateLBCookieStickinessPolicy {
    type Output = std::result::Result<
        crate::output::CreateLbCookieStickinessPolicyOutput,
        crate::error::CreateLBCookieStickinessPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_lb_cookie_stickiness_policy_error(response)
        } else {
            crate::operation_deser::parse_create_lb_cookie_stickiness_policy_response(response)
        }
    }
}

/// <p>Creates a Classic Load Balancer.</p>
/// <p>You can add listeners, security groups, subnets, and tags when you create your load balancer,
/// or you can add them later using <a>CreateLoadBalancerListeners</a>,
/// <a>ApplySecurityGroupsToLoadBalancer</a>, <a>AttachLoadBalancerToSubnets</a>,
/// and <a>AddTags</a>.</p>
/// <p>To describe your current load balancers, see <a>DescribeLoadBalancers</a>.
/// When you are finished with a load balancer, you can delete it using
/// <a>DeleteLoadBalancer</a>.</p>
/// <p>You can create up to 20 load balancers per region per account.
/// You can request an increase for the number of load balancers for your account.
/// For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-limits.html">Limits for Your Classic Load Balancer</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateLoadBalancer {
    _private: (),
}
impl CreateLoadBalancer {
    /// Creates a new builder-style object to manufacture [`CreateLoadBalancerInput`](crate::input::CreateLoadBalancerInput)
    pub fn builder() -> crate::input::create_load_balancer_input::Builder {
        crate::input::create_load_balancer_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateLoadBalancer {
    type Output = std::result::Result<
        crate::output::CreateLoadBalancerOutput,
        crate::error::CreateLoadBalancerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_load_balancer_error(response)
        } else {
            crate::operation_deser::parse_create_load_balancer_response(response)
        }
    }
}

/// <p>Creates one or more listeners for the specified load balancer. If a listener with the specified port does not already exist, it is created; otherwise, the properties of the new listener must match the properties of the existing listener.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-listener-config.html">Listeners for Your Classic Load Balancer</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateLoadBalancerListeners {
    _private: (),
}
impl CreateLoadBalancerListeners {
    /// Creates a new builder-style object to manufacture [`CreateLoadBalancerListenersInput`](crate::input::CreateLoadBalancerListenersInput)
    pub fn builder() -> crate::input::create_load_balancer_listeners_input::Builder {
        crate::input::create_load_balancer_listeners_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateLoadBalancerListeners {
    type Output = std::result::Result<
        crate::output::CreateLoadBalancerListenersOutput,
        crate::error::CreateLoadBalancerListenersError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_load_balancer_listeners_error(response)
        } else {
            crate::operation_deser::parse_create_load_balancer_listeners_response(response)
        }
    }
}

/// <p>Creates a policy with the specified attributes for the specified load balancer.</p>
/// <p>Policies are settings that are saved for your load balancer and that can be applied to the listener or the application server, depending on the policy type.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateLoadBalancerPolicy {
    _private: (),
}
impl CreateLoadBalancerPolicy {
    /// Creates a new builder-style object to manufacture [`CreateLoadBalancerPolicyInput`](crate::input::CreateLoadBalancerPolicyInput)
    pub fn builder() -> crate::input::create_load_balancer_policy_input::Builder {
        crate::input::create_load_balancer_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateLoadBalancerPolicy {
    type Output = std::result::Result<
        crate::output::CreateLoadBalancerPolicyOutput,
        crate::error::CreateLoadBalancerPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_load_balancer_policy_error(response)
        } else {
            crate::operation_deser::parse_create_load_balancer_policy_response(response)
        }
    }
}

/// <p>Deletes the specified load balancer.</p>
/// <p>If you are attempting to recreate a load balancer, you must reconfigure all settings. The DNS name associated with a deleted load balancer are no longer usable. The name and associated DNS record of the deleted load balancer no longer exist and traffic sent to any of its IP addresses is no longer delivered to your instances.</p>
/// <p>If the load balancer does not exist or has already been deleted, the call to
/// <code>DeleteLoadBalancer</code> still succeeds.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteLoadBalancer {
    _private: (),
}
impl DeleteLoadBalancer {
    /// Creates a new builder-style object to manufacture [`DeleteLoadBalancerInput`](crate::input::DeleteLoadBalancerInput)
    pub fn builder() -> crate::input::delete_load_balancer_input::Builder {
        crate::input::delete_load_balancer_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteLoadBalancer {
    type Output = std::result::Result<
        crate::output::DeleteLoadBalancerOutput,
        crate::error::DeleteLoadBalancerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_load_balancer_error(response)
        } else {
            crate::operation_deser::parse_delete_load_balancer_response(response)
        }
    }
}

/// <p>Deletes the specified listeners from the specified load balancer.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteLoadBalancerListeners {
    _private: (),
}
impl DeleteLoadBalancerListeners {
    /// Creates a new builder-style object to manufacture [`DeleteLoadBalancerListenersInput`](crate::input::DeleteLoadBalancerListenersInput)
    pub fn builder() -> crate::input::delete_load_balancer_listeners_input::Builder {
        crate::input::delete_load_balancer_listeners_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteLoadBalancerListeners {
    type Output = std::result::Result<
        crate::output::DeleteLoadBalancerListenersOutput,
        crate::error::DeleteLoadBalancerListenersError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_load_balancer_listeners_error(response)
        } else {
            crate::operation_deser::parse_delete_load_balancer_listeners_response(response)
        }
    }
}

/// <p>Deletes the specified policy from the specified load balancer. This policy must not be enabled for any listeners.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteLoadBalancerPolicy {
    _private: (),
}
impl DeleteLoadBalancerPolicy {
    /// Creates a new builder-style object to manufacture [`DeleteLoadBalancerPolicyInput`](crate::input::DeleteLoadBalancerPolicyInput)
    pub fn builder() -> crate::input::delete_load_balancer_policy_input::Builder {
        crate::input::delete_load_balancer_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteLoadBalancerPolicy {
    type Output = std::result::Result<
        crate::output::DeleteLoadBalancerPolicyOutput,
        crate::error::DeleteLoadBalancerPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_load_balancer_policy_error(response)
        } else {
            crate::operation_deser::parse_delete_load_balancer_policy_response(response)
        }
    }
}

/// <p>Deregisters the specified instances from the specified load balancer. After the instance is deregistered, it no longer receives traffic from the load balancer.</p>
/// <p>You can use <a>DescribeLoadBalancers</a> to verify that the instance is deregistered from the load balancer.</p>  
/// <p>For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-deregister-register-instances.html">Register or De-Register EC2 Instances</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeregisterInstancesFromLoadBalancer {
    _private: (),
}
impl DeregisterInstancesFromLoadBalancer {
    /// Creates a new builder-style object to manufacture [`DeregisterInstancesFromLoadBalancerInput`](crate::input::DeregisterInstancesFromLoadBalancerInput)
    pub fn builder() -> crate::input::deregister_instances_from_load_balancer_input::Builder {
        crate::input::deregister_instances_from_load_balancer_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeregisterInstancesFromLoadBalancer {
    type Output = std::result::Result<
        crate::output::DeregisterInstancesFromLoadBalancerOutput,
        crate::error::DeregisterInstancesFromLoadBalancerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_deregister_instances_from_load_balancer_error(response)
        } else {
            crate::operation_deser::parse_deregister_instances_from_load_balancer_response(response)
        }
    }
}

/// <p>Describes the current Elastic Load Balancing resource limits for your AWS account.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-limits.html">Limits for Your Classic Load Balancer</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeAccountLimits {
    _private: (),
}
impl DescribeAccountLimits {
    /// Creates a new builder-style object to manufacture [`DescribeAccountLimitsInput`](crate::input::DescribeAccountLimitsInput)
    pub fn builder() -> crate::input::describe_account_limits_input::Builder {
        crate::input::describe_account_limits_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeAccountLimits {
    type Output = std::result::Result<
        crate::output::DescribeAccountLimitsOutput,
        crate::error::DescribeAccountLimitsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_account_limits_error(response)
        } else {
            crate::operation_deser::parse_describe_account_limits_response(response)
        }
    }
}

/// <p>Describes the state of the specified instances with respect to the specified load balancer. If no instances are specified, the call describes the state of all instances that are currently registered with the load balancer. If instances are specified, their state is returned even if they are no longer registered with the load balancer. The state of terminated instances is not returned.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeInstanceHealth {
    _private: (),
}
impl DescribeInstanceHealth {
    /// Creates a new builder-style object to manufacture [`DescribeInstanceHealthInput`](crate::input::DescribeInstanceHealthInput)
    pub fn builder() -> crate::input::describe_instance_health_input::Builder {
        crate::input::describe_instance_health_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeInstanceHealth {
    type Output = std::result::Result<
        crate::output::DescribeInstanceHealthOutput,
        crate::error::DescribeInstanceHealthError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_instance_health_error(response)
        } else {
            crate::operation_deser::parse_describe_instance_health_response(response)
        }
    }
}

/// <p>Describes the attributes for the specified load balancer.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeLoadBalancerAttributes {
    _private: (),
}
impl DescribeLoadBalancerAttributes {
    /// Creates a new builder-style object to manufacture [`DescribeLoadBalancerAttributesInput`](crate::input::DescribeLoadBalancerAttributesInput)
    pub fn builder() -> crate::input::describe_load_balancer_attributes_input::Builder {
        crate::input::describe_load_balancer_attributes_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeLoadBalancerAttributes {
    type Output = std::result::Result<
        crate::output::DescribeLoadBalancerAttributesOutput,
        crate::error::DescribeLoadBalancerAttributesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_load_balancer_attributes_error(response)
        } else {
            crate::operation_deser::parse_describe_load_balancer_attributes_response(response)
        }
    }
}

/// <p>Describes the specified policies.</p>
/// <p>If you specify a load balancer name, the action returns the descriptions of all policies created for the load balancer.
/// If you specify a policy name associated with your load balancer, the action returns the description of that policy.
/// If you don't specify a load balancer name, the action returns descriptions of the specified sample policies, or descriptions of all sample policies.
/// The names of the sample policies have the <code>ELBSample-</code> prefix.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeLoadBalancerPolicies {
    _private: (),
}
impl DescribeLoadBalancerPolicies {
    /// Creates a new builder-style object to manufacture [`DescribeLoadBalancerPoliciesInput`](crate::input::DescribeLoadBalancerPoliciesInput)
    pub fn builder() -> crate::input::describe_load_balancer_policies_input::Builder {
        crate::input::describe_load_balancer_policies_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeLoadBalancerPolicies {
    type Output = std::result::Result<
        crate::output::DescribeLoadBalancerPoliciesOutput,
        crate::error::DescribeLoadBalancerPoliciesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_load_balancer_policies_error(response)
        } else {
            crate::operation_deser::parse_describe_load_balancer_policies_response(response)
        }
    }
}

/// <p>Describes the specified load balancer policy types or all load balancer policy types.</p>
/// <p>The description of each type indicates how it can be used. For example,
/// some policies can be used only with layer 7 listeners,
/// some policies can be used only with layer 4 listeners,
/// and some policies can be used only with your EC2 instances.</p>
/// <p>You can use <a>CreateLoadBalancerPolicy</a> to create a policy configuration for any of these policy types.
/// Then, depending on the policy type, use either <a>SetLoadBalancerPoliciesOfListener</a> or
/// <a>SetLoadBalancerPoliciesForBackendServer</a> to set the policy.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeLoadBalancerPolicyTypes {
    _private: (),
}
impl DescribeLoadBalancerPolicyTypes {
    /// Creates a new builder-style object to manufacture [`DescribeLoadBalancerPolicyTypesInput`](crate::input::DescribeLoadBalancerPolicyTypesInput)
    pub fn builder() -> crate::input::describe_load_balancer_policy_types_input::Builder {
        crate::input::describe_load_balancer_policy_types_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeLoadBalancerPolicyTypes {
    type Output = std::result::Result<
        crate::output::DescribeLoadBalancerPolicyTypesOutput,
        crate::error::DescribeLoadBalancerPolicyTypesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_load_balancer_policy_types_error(response)
        } else {
            crate::operation_deser::parse_describe_load_balancer_policy_types_response(response)
        }
    }
}

/// <p>Describes the specified the load balancers. If no load balancers are specified, the call describes all of your load balancers.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeLoadBalancers {
    _private: (),
}
impl DescribeLoadBalancers {
    /// Creates a new builder-style object to manufacture [`DescribeLoadBalancersInput`](crate::input::DescribeLoadBalancersInput)
    pub fn builder() -> crate::input::describe_load_balancers_input::Builder {
        crate::input::describe_load_balancers_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeLoadBalancers {
    type Output = std::result::Result<
        crate::output::DescribeLoadBalancersOutput,
        crate::error::DescribeLoadBalancersError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_load_balancers_error(response)
        } else {
            crate::operation_deser::parse_describe_load_balancers_response(response)
        }
    }
}

/// <p>Describes the tags associated with the specified load balancers.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeTags {
    _private: (),
}
impl DescribeTags {
    /// Creates a new builder-style object to manufacture [`DescribeTagsInput`](crate::input::DescribeTagsInput)
    pub fn builder() -> crate::input::describe_tags_input::Builder {
        crate::input::describe_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeTags {
    type Output =
        std::result::Result<crate::output::DescribeTagsOutput, crate::error::DescribeTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_tags_error(response)
        } else {
            crate::operation_deser::parse_describe_tags_response(response)
        }
    }
}

/// <p>Removes the specified subnets from the set of configured subnets for the load balancer.</p>
/// <p>After a subnet is removed, all EC2 instances registered with the load balancer  
/// in the removed subnet go into the <code>OutOfService</code> state. Then,
/// the load balancer balances the traffic among the remaining routable subnets.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DetachLoadBalancerFromSubnets {
    _private: (),
}
impl DetachLoadBalancerFromSubnets {
    /// Creates a new builder-style object to manufacture [`DetachLoadBalancerFromSubnetsInput`](crate::input::DetachLoadBalancerFromSubnetsInput)
    pub fn builder() -> crate::input::detach_load_balancer_from_subnets_input::Builder {
        crate::input::detach_load_balancer_from_subnets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DetachLoadBalancerFromSubnets {
    type Output = std::result::Result<
        crate::output::DetachLoadBalancerFromSubnetsOutput,
        crate::error::DetachLoadBalancerFromSubnetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_detach_load_balancer_from_subnets_error(response)
        } else {
            crate::operation_deser::parse_detach_load_balancer_from_subnets_response(response)
        }
    }
}

/// <p>Removes the specified Availability Zones from the set of Availability Zones for the specified load balancer
/// in EC2-Classic or a default VPC.</p>
/// <p>For load balancers in a non-default VPC, use <a>DetachLoadBalancerFromSubnets</a>.</p>
/// <p>There must be at least one Availability Zone registered with a load balancer at all times.
/// After an Availability Zone is removed, all instances registered with the load balancer that are in the removed
/// Availability Zone go into the <code>OutOfService</code> state. Then, the load balancer attempts to equally balance
/// the traffic among its remaining Availability Zones.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/enable-disable-az.html">Add or Remove Availability Zones</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DisableAvailabilityZonesForLoadBalancer {
    _private: (),
}
impl DisableAvailabilityZonesForLoadBalancer {
    /// Creates a new builder-style object to manufacture [`DisableAvailabilityZonesForLoadBalancerInput`](crate::input::DisableAvailabilityZonesForLoadBalancerInput)
    pub fn builder() -> crate::input::disable_availability_zones_for_load_balancer_input::Builder {
        crate::input::disable_availability_zones_for_load_balancer_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DisableAvailabilityZonesForLoadBalancer {
    type Output = std::result::Result<
        crate::output::DisableAvailabilityZonesForLoadBalancerOutput,
        crate::error::DisableAvailabilityZonesForLoadBalancerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_disable_availability_zones_for_load_balancer_error(
                response,
            )
        } else {
            crate::operation_deser::parse_disable_availability_zones_for_load_balancer_response(
                response,
            )
        }
    }
}

/// <p>Adds the specified Availability Zones to the set of Availability Zones for the specified load balancer
/// in EC2-Classic or a default VPC.</p>
/// <p>For load balancers in a non-default VPC, use <a>AttachLoadBalancerToSubnets</a>.</p>
/// <p>The load balancer evenly distributes requests across all its registered Availability Zones
/// that contain instances. For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/enable-disable-az.html">Add or Remove Availability Zones</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct EnableAvailabilityZonesForLoadBalancer {
    _private: (),
}
impl EnableAvailabilityZonesForLoadBalancer {
    /// Creates a new builder-style object to manufacture [`EnableAvailabilityZonesForLoadBalancerInput`](crate::input::EnableAvailabilityZonesForLoadBalancerInput)
    pub fn builder() -> crate::input::enable_availability_zones_for_load_balancer_input::Builder {
        crate::input::enable_availability_zones_for_load_balancer_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for EnableAvailabilityZonesForLoadBalancer {
    type Output = std::result::Result<
        crate::output::EnableAvailabilityZonesForLoadBalancerOutput,
        crate::error::EnableAvailabilityZonesForLoadBalancerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_enable_availability_zones_for_load_balancer_error(
                response,
            )
        } else {
            crate::operation_deser::parse_enable_availability_zones_for_load_balancer_response(
                response,
            )
        }
    }
}

/// <p>Modifies the attributes of the specified load balancer.</p>
/// <p>You can modify the load balancer attributes, such as <code>AccessLogs</code>, <code>ConnectionDraining</code>, and
/// <code>CrossZoneLoadBalancing</code> by either enabling or disabling them. Or, you can modify the load balancer attribute
/// <code>ConnectionSettings</code> by specifying an idle connection timeout value for your load balancer.</p>
/// <p>For more information, see the following in the <i>Classic Load Balancers Guide</i>:</p>
/// <ul>
/// <li>
/// <p>
/// <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/enable-disable-crosszone-lb.html">Cross-Zone Load Balancing</a>
/// </p>
/// </li>
/// <li>
/// <p>
/// <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/config-conn-drain.html">Connection Draining</a>
/// </p>
/// </li>
/// <li>
/// <p>
/// <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/access-log-collection.html">Access Logs</a>
/// </p>
/// </li>
/// <li>
/// <p>
/// <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/config-idle-timeout.html">Idle Connection Timeout</a>
/// </p>
/// </li>
/// </ul>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyLoadBalancerAttributes {
    _private: (),
}
impl ModifyLoadBalancerAttributes {
    /// Creates a new builder-style object to manufacture [`ModifyLoadBalancerAttributesInput`](crate::input::ModifyLoadBalancerAttributesInput)
    pub fn builder() -> crate::input::modify_load_balancer_attributes_input::Builder {
        crate::input::modify_load_balancer_attributes_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyLoadBalancerAttributes {
    type Output = std::result::Result<
        crate::output::ModifyLoadBalancerAttributesOutput,
        crate::error::ModifyLoadBalancerAttributesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_load_balancer_attributes_error(response)
        } else {
            crate::operation_deser::parse_modify_load_balancer_attributes_response(response)
        }
    }
}

/// <p>Adds the specified instances to the specified load balancer.</p>
/// <p>The instance must be a running instance in the same network as the load balancer (EC2-Classic or the same VPC). If you have EC2-Classic instances and a load balancer in a VPC with ClassicLink enabled, you can link the EC2-Classic instances to that VPC and then register the linked EC2-Classic instances with the load balancer in the VPC.</p>
/// <p>Note that <code>RegisterInstanceWithLoadBalancer</code> completes when the request has been registered.
/// Instance registration takes a little time to complete. To check the state of the registered instances, use
/// <a>DescribeLoadBalancers</a> or <a>DescribeInstanceHealth</a>.</p>  
/// <p>After the instance is registered, it starts receiving traffic
/// and requests from the load balancer. Any instance that is not
/// in one of the Availability Zones registered for the load balancer
/// is moved to the <code>OutOfService</code> state. If an Availability Zone
/// is added to the load balancer later, any instances registered with the
/// load balancer move to the <code>InService</code> state.</p>
/// <p>To deregister instances from a load balancer, use <a>DeregisterInstancesFromLoadBalancer</a>.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-deregister-register-instances.html">Register or De-Register EC2 Instances</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RegisterInstancesWithLoadBalancer {
    _private: (),
}
impl RegisterInstancesWithLoadBalancer {
    /// Creates a new builder-style object to manufacture [`RegisterInstancesWithLoadBalancerInput`](crate::input::RegisterInstancesWithLoadBalancerInput)
    pub fn builder() -> crate::input::register_instances_with_load_balancer_input::Builder {
        crate::input::register_instances_with_load_balancer_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RegisterInstancesWithLoadBalancer {
    type Output = std::result::Result<
        crate::output::RegisterInstancesWithLoadBalancerOutput,
        crate::error::RegisterInstancesWithLoadBalancerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_register_instances_with_load_balancer_error(response)
        } else {
            crate::operation_deser::parse_register_instances_with_load_balancer_response(response)
        }
    }
}

/// <p>Removes one or more tags from the specified load balancer.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RemoveTags {
    _private: (),
}
impl RemoveTags {
    /// Creates a new builder-style object to manufacture [`RemoveTagsInput`](crate::input::RemoveTagsInput)
    pub fn builder() -> crate::input::remove_tags_input::Builder {
        crate::input::remove_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RemoveTags {
    type Output =
        std::result::Result<crate::output::RemoveTagsOutput, crate::error::RemoveTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_remove_tags_error(response)
        } else {
            crate::operation_deser::parse_remove_tags_response(response)
        }
    }
}

/// <p>Sets the certificate that terminates the specified listener's SSL connections. The specified certificate replaces any prior certificate that was used on the same load balancer and port.</p>
/// <p>For more information about updating your SSL certificate, see
/// <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-update-ssl-cert.html">Replace the SSL Certificate for Your Load Balancer</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SetLoadBalancerListenerSSLCertificate {
    _private: (),
}
impl SetLoadBalancerListenerSSLCertificate {
    /// Creates a new builder-style object to manufacture [`SetLoadBalancerListenerSslCertificateInput`](crate::input::SetLoadBalancerListenerSslCertificateInput)
    pub fn builder() -> crate::input::set_load_balancer_listener_ssl_certificate_input::Builder {
        crate::input::set_load_balancer_listener_ssl_certificate_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SetLoadBalancerListenerSSLCertificate {
    type Output = std::result::Result<
        crate::output::SetLoadBalancerListenerSslCertificateOutput,
        crate::error::SetLoadBalancerListenerSSLCertificateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_set_load_balancer_listener_ssl_certificate_error(response)
        } else {
            crate::operation_deser::parse_set_load_balancer_listener_ssl_certificate_response(
                response,
            )
        }
    }
}

/// <p>Replaces the set of policies associated with the specified port on which the EC2 instance is listening with a new set of policies.
/// At this time, only the back-end server authentication policy type can be applied to the instance ports; this policy type is composed of multiple public key policies.</p>
/// <p>Each time you use <code>SetLoadBalancerPoliciesForBackendServer</code> to enable the policies,
/// use the <code>PolicyNames</code> parameter to list the policies that you want to enable.</p>
/// <p>You can use <a>DescribeLoadBalancers</a> or <a>DescribeLoadBalancerPolicies</a> to verify that the policy
/// is associated with the EC2 instance.</p>     
/// <p>For more information about enabling back-end instance authentication, see <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-create-https-ssl-load-balancer.html#configure_backendauth_clt">Configure Back-end Instance Authentication</a>
/// in the <i>Classic Load Balancers Guide</i>. For more information about Proxy Protocol, see
/// <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/enable-proxy-protocol.html">Configure Proxy Protocol Support</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SetLoadBalancerPoliciesForBackendServer {
    _private: (),
}
impl SetLoadBalancerPoliciesForBackendServer {
    /// Creates a new builder-style object to manufacture [`SetLoadBalancerPoliciesForBackendServerInput`](crate::input::SetLoadBalancerPoliciesForBackendServerInput)
    pub fn builder() -> crate::input::set_load_balancer_policies_for_backend_server_input::Builder {
        crate::input::set_load_balancer_policies_for_backend_server_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SetLoadBalancerPoliciesForBackendServer {
    type Output = std::result::Result<
        crate::output::SetLoadBalancerPoliciesForBackendServerOutput,
        crate::error::SetLoadBalancerPoliciesForBackendServerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_set_load_balancer_policies_for_backend_server_error(
                response,
            )
        } else {
            crate::operation_deser::parse_set_load_balancer_policies_for_backend_server_response(
                response,
            )
        }
    }
}

/// <p>Replaces the current set of policies for the specified load balancer port with the specified set of policies.</p>
/// <p>To enable back-end server authentication, use <a>SetLoadBalancerPoliciesForBackendServer</a>.</p>
/// <p>For more information about setting policies, see
/// <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/ssl-config-update.html">Update the SSL Negotiation Configuration</a>,
/// <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-sticky-sessions.html#enable-sticky-sessions-duration">Duration-Based Session Stickiness</a>, and
/// <a href="https://docs.aws.amazon.com/elasticloadbalancing/latest/classic/elb-sticky-sessions.html#enable-sticky-sessions-application">Application-Controlled Session Stickiness</a>
/// in the <i>Classic Load Balancers Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SetLoadBalancerPoliciesOfListener {
    _private: (),
}
impl SetLoadBalancerPoliciesOfListener {
    /// Creates a new builder-style object to manufacture [`SetLoadBalancerPoliciesOfListenerInput`](crate::input::SetLoadBalancerPoliciesOfListenerInput)
    pub fn builder() -> crate::input::set_load_balancer_policies_of_listener_input::Builder {
        crate::input::set_load_balancer_policies_of_listener_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SetLoadBalancerPoliciesOfListener {
    type Output = std::result::Result<
        crate::output::SetLoadBalancerPoliciesOfListenerOutput,
        crate::error::SetLoadBalancerPoliciesOfListenerError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_set_load_balancer_policies_of_listener_error(response)
        } else {
            crate::operation_deser::parse_set_load_balancer_policies_of_listener_response(response)
        }
    }
}
