// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <p>Adds an instance fleet to a running cluster.</p>
/// <note>
/// <p>The instance fleet configuration is available only in Amazon EMR versions 4.8.0 and
/// later, excluding 5.0.x.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddInstanceFleet {
    _private: (),
}
impl AddInstanceFleet {
    /// Creates a new builder-style object to manufacture [`AddInstanceFleetInput`](crate::input::AddInstanceFleetInput)
    pub fn builder() -> crate::input::add_instance_fleet_input::Builder {
        crate::input::add_instance_fleet_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddInstanceFleet {
    type Output = std::result::Result<
        crate::output::AddInstanceFleetOutput,
        crate::error::AddInstanceFleetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_instance_fleet_error(response)
        } else {
            crate::operation_deser::parse_add_instance_fleet_response(response)
        }
    }
}

/// <p>Adds one or more instance groups to a running cluster.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddInstanceGroups {
    _private: (),
}
impl AddInstanceGroups {
    /// Creates a new builder-style object to manufacture [`AddInstanceGroupsInput`](crate::input::AddInstanceGroupsInput)
    pub fn builder() -> crate::input::add_instance_groups_input::Builder {
        crate::input::add_instance_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddInstanceGroups {
    type Output = std::result::Result<
        crate::output::AddInstanceGroupsOutput,
        crate::error::AddInstanceGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_instance_groups_error(response)
        } else {
            crate::operation_deser::parse_add_instance_groups_response(response)
        }
    }
}

/// <p>AddJobFlowSteps adds new steps to a running cluster. A maximum of 256 steps are allowed
/// in each job flow.</p>
/// <p>If your cluster is long-running (such as a Hive data warehouse) or complex, you may
/// require more than 256 steps to process your data. You can bypass the 256-step limitation in
/// various ways, including using SSH to connect to the master node and submitting queries
/// directly to the software running on the master node, such as Hive and Hadoop. For more
/// information on how to do this, see <a href="https://docs.aws.amazon.com/emr/latest/ManagementGuide/AddMoreThan256Steps.html">Add More than 256 Steps to a
/// Cluster</a> in the <i>Amazon EMR Management Guide</i>.</p>
/// <p>A step specifies the location of a JAR file stored either on the master node of the
/// cluster or in Amazon S3. Each step is performed by the main function of the main class of
/// the JAR file. The main class can be specified either in the manifest of the JAR or by using
/// the MainFunction parameter of the step.</p>
/// <p>Amazon EMR executes each step in the order listed. For a step to be considered complete,
/// the main function must exit with a zero exit code and all Hadoop jobs started while the
/// step was running must have completed and run successfully.</p>
/// <p>You can only add steps to a cluster that is in one of the following states: STARTING,
/// BOOTSTRAPPING, RUNNING, or WAITING.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddJobFlowSteps {
    _private: (),
}
impl AddJobFlowSteps {
    /// Creates a new builder-style object to manufacture [`AddJobFlowStepsInput`](crate::input::AddJobFlowStepsInput)
    pub fn builder() -> crate::input::add_job_flow_steps_input::Builder {
        crate::input::add_job_flow_steps_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddJobFlowSteps {
    type Output = std::result::Result<
        crate::output::AddJobFlowStepsOutput,
        crate::error::AddJobFlowStepsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_job_flow_steps_error(response)
        } else {
            crate::operation_deser::parse_add_job_flow_steps_response(response)
        }
    }
}

/// <p>Adds tags to an Amazon EMR resource. Tags make it easier to associate clusters in
/// various ways, such as grouping clusters to track your Amazon EMR resource allocation costs.
/// For more information, see <a href="https://docs.aws.amazon.com/emr/latest/ManagementGuide/emr-plan-tags.html">Tag Clusters</a>. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddTags {
    _private: (),
}
impl AddTags {
    /// Creates a new builder-style object to manufacture [`AddTagsInput`](crate::input::AddTagsInput)
    pub fn builder() -> crate::input::add_tags_input::Builder {
        crate::input::add_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddTags {
    type Output = std::result::Result<crate::output::AddTagsOutput, crate::error::AddTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_tags_error(response)
        } else {
            crate::operation_deser::parse_add_tags_response(response)
        }
    }
}

/// <p>Cancels a pending step or steps in a running cluster. Available only in Amazon EMR
/// versions 4.8.0 and later, excluding version 5.0.0. A maximum of 256 steps are allowed in
/// each CancelSteps request. CancelSteps is idempotent but asynchronous; it does not guarantee
/// that a step will be canceled, even if the request is successfully submitted. When you use Amazon EMR versions 5.28.0 and later, you can cancel steps that are in a <code>PENDING</code> or <code>RUNNING</code> state. In earlier versions of Amazon EMR, you can only cancel steps that are in a <code>PENDING</code> state. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CancelSteps {
    _private: (),
}
impl CancelSteps {
    /// Creates a new builder-style object to manufacture [`CancelStepsInput`](crate::input::CancelStepsInput)
    pub fn builder() -> crate::input::cancel_steps_input::Builder {
        crate::input::cancel_steps_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CancelSteps {
    type Output =
        std::result::Result<crate::output::CancelStepsOutput, crate::error::CancelStepsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_cancel_steps_error(response)
        } else {
            crate::operation_deser::parse_cancel_steps_response(response)
        }
    }
}

/// <p>Creates a security configuration, which is stored in the service and can be specified
/// when a cluster is created.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateSecurityConfiguration {
    _private: (),
}
impl CreateSecurityConfiguration {
    /// Creates a new builder-style object to manufacture [`CreateSecurityConfigurationInput`](crate::input::CreateSecurityConfigurationInput)
    pub fn builder() -> crate::input::create_security_configuration_input::Builder {
        crate::input::create_security_configuration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateSecurityConfiguration {
    type Output = std::result::Result<
        crate::output::CreateSecurityConfigurationOutput,
        crate::error::CreateSecurityConfigurationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_security_configuration_error(response)
        } else {
            crate::operation_deser::parse_create_security_configuration_response(response)
        }
    }
}

/// <p>Creates a new Amazon EMR Studio.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateStudio {
    _private: (),
}
impl CreateStudio {
    /// Creates a new builder-style object to manufacture [`CreateStudioInput`](crate::input::CreateStudioInput)
    pub fn builder() -> crate::input::create_studio_input::Builder {
        crate::input::create_studio_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateStudio {
    type Output =
        std::result::Result<crate::output::CreateStudioOutput, crate::error::CreateStudioError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_studio_error(response)
        } else {
            crate::operation_deser::parse_create_studio_response(response)
        }
    }
}

/// <p>Maps a user or group to the Amazon EMR Studio specified by <code>StudioId</code>, and
/// applies a session policy to refine Studio permissions for that user or group.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateStudioSessionMapping {
    _private: (),
}
impl CreateStudioSessionMapping {
    /// Creates a new builder-style object to manufacture [`CreateStudioSessionMappingInput`](crate::input::CreateStudioSessionMappingInput)
    pub fn builder() -> crate::input::create_studio_session_mapping_input::Builder {
        crate::input::create_studio_session_mapping_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateStudioSessionMapping {
    type Output = std::result::Result<
        crate::output::CreateStudioSessionMappingOutput,
        crate::error::CreateStudioSessionMappingError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_studio_session_mapping_error(response)
        } else {
            crate::operation_deser::parse_create_studio_session_mapping_response(response)
        }
    }
}

/// <p>Deletes a security configuration.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteSecurityConfiguration {
    _private: (),
}
impl DeleteSecurityConfiguration {
    /// Creates a new builder-style object to manufacture [`DeleteSecurityConfigurationInput`](crate::input::DeleteSecurityConfigurationInput)
    pub fn builder() -> crate::input::delete_security_configuration_input::Builder {
        crate::input::delete_security_configuration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteSecurityConfiguration {
    type Output = std::result::Result<
        crate::output::DeleteSecurityConfigurationOutput,
        crate::error::DeleteSecurityConfigurationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_security_configuration_error(response)
        } else {
            crate::operation_deser::parse_delete_security_configuration_response(response)
        }
    }
}

/// <p>Removes an Amazon EMR Studio from the Studio metadata store.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteStudio {
    _private: (),
}
impl DeleteStudio {
    /// Creates a new builder-style object to manufacture [`DeleteStudioInput`](crate::input::DeleteStudioInput)
    pub fn builder() -> crate::input::delete_studio_input::Builder {
        crate::input::delete_studio_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteStudio {
    type Output =
        std::result::Result<crate::output::DeleteStudioOutput, crate::error::DeleteStudioError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_studio_error(response)
        } else {
            crate::operation_deser::parse_delete_studio_response(response)
        }
    }
}

/// <p>Removes a user or group from an Amazon EMR Studio.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteStudioSessionMapping {
    _private: (),
}
impl DeleteStudioSessionMapping {
    /// Creates a new builder-style object to manufacture [`DeleteStudioSessionMappingInput`](crate::input::DeleteStudioSessionMappingInput)
    pub fn builder() -> crate::input::delete_studio_session_mapping_input::Builder {
        crate::input::delete_studio_session_mapping_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteStudioSessionMapping {
    type Output = std::result::Result<
        crate::output::DeleteStudioSessionMappingOutput,
        crate::error::DeleteStudioSessionMappingError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_studio_session_mapping_error(response)
        } else {
            crate::operation_deser::parse_delete_studio_session_mapping_response(response)
        }
    }
}

/// <p>Provides cluster-level details including status, hardware and software configuration,
/// VPC settings, and so on.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeCluster {
    _private: (),
}
impl DescribeCluster {
    /// Creates a new builder-style object to manufacture [`DescribeClusterInput`](crate::input::DescribeClusterInput)
    pub fn builder() -> crate::input::describe_cluster_input::Builder {
        crate::input::describe_cluster_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeCluster {
    type Output = std::result::Result<
        crate::output::DescribeClusterOutput,
        crate::error::DescribeClusterError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_cluster_error(response)
        } else {
            crate::operation_deser::parse_describe_cluster_response(response)
        }
    }
}

/// <p>This API is no longer supported and will eventually be removed. We recommend you use
/// <a>ListClusters</a>, <a>DescribeCluster</a>, <a>ListSteps</a>, <a>ListInstanceGroups</a> and <a>ListBootstrapActions</a> instead.</p>
/// <p>DescribeJobFlows returns a list of job flows that match all of the supplied parameters.
/// The parameters can include a list of job flow IDs, job flow states, and restrictions on job
/// flow creation date and time.</p>
/// <p>Regardless of supplied parameters, only job flows created within the last two months are
/// returned.</p>
/// <p>If no parameters are supplied, then job flows matching either of the following criteria
/// are returned:</p>
/// <ul>
/// <li>
/// <p>Job flows created and completed in the last two weeks</p>
/// </li>
/// <li>
/// <p> Job flows created within the last two months that are in one of the following
/// states: <code>RUNNING</code>, <code>WAITING</code>, <code>SHUTTING_DOWN</code>,
/// <code>STARTING</code>
/// </p>
/// </li>
/// </ul>
/// <p>Amazon EMR can return a maximum of 512 job flow descriptions.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeJobFlows {
    _private: (),
}
impl DescribeJobFlows {
    /// Creates a new builder-style object to manufacture [`DescribeJobFlowsInput`](crate::input::DescribeJobFlowsInput)
    pub fn builder() -> crate::input::describe_job_flows_input::Builder {
        crate::input::describe_job_flows_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeJobFlows {
    type Output = std::result::Result<
        crate::output::DescribeJobFlowsOutput,
        crate::error::DescribeJobFlowsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_job_flows_error(response)
        } else {
            crate::operation_deser::parse_describe_job_flows_response(response)
        }
    }
}

/// <p>Provides details of a notebook execution.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeNotebookExecution {
    _private: (),
}
impl DescribeNotebookExecution {
    /// Creates a new builder-style object to manufacture [`DescribeNotebookExecutionInput`](crate::input::DescribeNotebookExecutionInput)
    pub fn builder() -> crate::input::describe_notebook_execution_input::Builder {
        crate::input::describe_notebook_execution_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeNotebookExecution {
    type Output = std::result::Result<
        crate::output::DescribeNotebookExecutionOutput,
        crate::error::DescribeNotebookExecutionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_notebook_execution_error(response)
        } else {
            crate::operation_deser::parse_describe_notebook_execution_response(response)
        }
    }
}

/// <p>Provides EMR release label details, such as releases available the region where the API request is run, and the available applications for a specific EMR release label. Can also list EMR release versions that support a specified version of Spark.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeReleaseLabel {
    _private: (),
}
impl DescribeReleaseLabel {
    /// Creates a new builder-style object to manufacture [`DescribeReleaseLabelInput`](crate::input::DescribeReleaseLabelInput)
    pub fn builder() -> crate::input::describe_release_label_input::Builder {
        crate::input::describe_release_label_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeReleaseLabel {
    type Output = std::result::Result<
        crate::output::DescribeReleaseLabelOutput,
        crate::error::DescribeReleaseLabelError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_release_label_error(response)
        } else {
            crate::operation_deser::parse_describe_release_label_response(response)
        }
    }
}

/// <p>Provides the details of a security configuration by returning the configuration
/// JSON.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeSecurityConfiguration {
    _private: (),
}
impl DescribeSecurityConfiguration {
    /// Creates a new builder-style object to manufacture [`DescribeSecurityConfigurationInput`](crate::input::DescribeSecurityConfigurationInput)
    pub fn builder() -> crate::input::describe_security_configuration_input::Builder {
        crate::input::describe_security_configuration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeSecurityConfiguration {
    type Output = std::result::Result<
        crate::output::DescribeSecurityConfigurationOutput,
        crate::error::DescribeSecurityConfigurationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_security_configuration_error(response)
        } else {
            crate::operation_deser::parse_describe_security_configuration_response(response)
        }
    }
}

/// <p>Provides more detail about the cluster step.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeStep {
    _private: (),
}
impl DescribeStep {
    /// Creates a new builder-style object to manufacture [`DescribeStepInput`](crate::input::DescribeStepInput)
    pub fn builder() -> crate::input::describe_step_input::Builder {
        crate::input::describe_step_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeStep {
    type Output =
        std::result::Result<crate::output::DescribeStepOutput, crate::error::DescribeStepError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_step_error(response)
        } else {
            crate::operation_deser::parse_describe_step_response(response)
        }
    }
}

/// <p>Returns details for the specified Amazon EMR Studio including ID, Name, VPC, Studio
/// access URL, and so on.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeStudio {
    _private: (),
}
impl DescribeStudio {
    /// Creates a new builder-style object to manufacture [`DescribeStudioInput`](crate::input::DescribeStudioInput)
    pub fn builder() -> crate::input::describe_studio_input::Builder {
        crate::input::describe_studio_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeStudio {
    type Output =
        std::result::Result<crate::output::DescribeStudioOutput, crate::error::DescribeStudioError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_studio_error(response)
        } else {
            crate::operation_deser::parse_describe_studio_response(response)
        }
    }
}

/// <p>Returns the Amazon EMR block public access configuration for your account in the
/// current Region. For more information see <a href="https://docs.aws.amazon.com/emr/latest/ManagementGuide/configure-block-public-access.html">Configure Block
/// Public Access for Amazon EMR</a> in the <i>Amazon EMR Management
/// Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetBlockPublicAccessConfiguration {
    _private: (),
}
impl GetBlockPublicAccessConfiguration {
    /// Creates a new builder-style object to manufacture [`GetBlockPublicAccessConfigurationInput`](crate::input::GetBlockPublicAccessConfigurationInput)
    pub fn builder() -> crate::input::get_block_public_access_configuration_input::Builder {
        crate::input::get_block_public_access_configuration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetBlockPublicAccessConfiguration {
    type Output = std::result::Result<
        crate::output::GetBlockPublicAccessConfigurationOutput,
        crate::error::GetBlockPublicAccessConfigurationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_block_public_access_configuration_error(response)
        } else {
            crate::operation_deser::parse_get_block_public_access_configuration_response(response)
        }
    }
}

/// <p>Fetches the attached managed scaling policy for an Amazon EMR cluster. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetManagedScalingPolicy {
    _private: (),
}
impl GetManagedScalingPolicy {
    /// Creates a new builder-style object to manufacture [`GetManagedScalingPolicyInput`](crate::input::GetManagedScalingPolicyInput)
    pub fn builder() -> crate::input::get_managed_scaling_policy_input::Builder {
        crate::input::get_managed_scaling_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetManagedScalingPolicy {
    type Output = std::result::Result<
        crate::output::GetManagedScalingPolicyOutput,
        crate::error::GetManagedScalingPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_managed_scaling_policy_error(response)
        } else {
            crate::operation_deser::parse_get_managed_scaling_policy_response(response)
        }
    }
}

/// <p>Fetches mapping details for the specified Amazon EMR Studio and identity (user or
/// group).</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetStudioSessionMapping {
    _private: (),
}
impl GetStudioSessionMapping {
    /// Creates a new builder-style object to manufacture [`GetStudioSessionMappingInput`](crate::input::GetStudioSessionMappingInput)
    pub fn builder() -> crate::input::get_studio_session_mapping_input::Builder {
        crate::input::get_studio_session_mapping_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetStudioSessionMapping {
    type Output = std::result::Result<
        crate::output::GetStudioSessionMappingOutput,
        crate::error::GetStudioSessionMappingError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_studio_session_mapping_error(response)
        } else {
            crate::operation_deser::parse_get_studio_session_mapping_response(response)
        }
    }
}

/// <p>Provides information about the bootstrap actions associated with a cluster.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListBootstrapActions {
    _private: (),
}
impl ListBootstrapActions {
    /// Creates a new builder-style object to manufacture [`ListBootstrapActionsInput`](crate::input::ListBootstrapActionsInput)
    pub fn builder() -> crate::input::list_bootstrap_actions_input::Builder {
        crate::input::list_bootstrap_actions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListBootstrapActions {
    type Output = std::result::Result<
        crate::output::ListBootstrapActionsOutput,
        crate::error::ListBootstrapActionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_bootstrap_actions_error(response)
        } else {
            crate::operation_deser::parse_list_bootstrap_actions_response(response)
        }
    }
}

/// <p>Provides the status of all clusters visible to this account. Allows you to filter
/// the list of clusters based on certain criteria; for example, filtering by cluster creation
/// date and time or by status. This call returns a maximum of 50 clusters in unsorted order per call, but
/// returns a marker to track the paging of the cluster list across multiple ListClusters
/// calls.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListClusters {
    _private: (),
}
impl ListClusters {
    /// Creates a new builder-style object to manufacture [`ListClustersInput`](crate::input::ListClustersInput)
    pub fn builder() -> crate::input::list_clusters_input::Builder {
        crate::input::list_clusters_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListClusters {
    type Output =
        std::result::Result<crate::output::ListClustersOutput, crate::error::ListClustersError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_clusters_error(response)
        } else {
            crate::operation_deser::parse_list_clusters_response(response)
        }
    }
}

/// <p>Lists all available details about the instance fleets in a cluster.</p>
/// <note>
/// <p>The instance fleet configuration is available only in Amazon EMR versions 4.8.0 and
/// later, excluding 5.0.x versions.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListInstanceFleets {
    _private: (),
}
impl ListInstanceFleets {
    /// Creates a new builder-style object to manufacture [`ListInstanceFleetsInput`](crate::input::ListInstanceFleetsInput)
    pub fn builder() -> crate::input::list_instance_fleets_input::Builder {
        crate::input::list_instance_fleets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListInstanceFleets {
    type Output = std::result::Result<
        crate::output::ListInstanceFleetsOutput,
        crate::error::ListInstanceFleetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_instance_fleets_error(response)
        } else {
            crate::operation_deser::parse_list_instance_fleets_response(response)
        }
    }
}

/// <p>Provides all available details about the instance groups in a cluster.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListInstanceGroups {
    _private: (),
}
impl ListInstanceGroups {
    /// Creates a new builder-style object to manufacture [`ListInstanceGroupsInput`](crate::input::ListInstanceGroupsInput)
    pub fn builder() -> crate::input::list_instance_groups_input::Builder {
        crate::input::list_instance_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListInstanceGroups {
    type Output = std::result::Result<
        crate::output::ListInstanceGroupsOutput,
        crate::error::ListInstanceGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_instance_groups_error(response)
        } else {
            crate::operation_deser::parse_list_instance_groups_response(response)
        }
    }
}

/// <p>Provides information for all active EC2 instances and EC2 instances terminated in the
/// last 30 days, up to a maximum of 2,000. EC2 instances in any of the following states are
/// considered active: AWAITING_FULFILLMENT, PROVISIONING, BOOTSTRAPPING, RUNNING.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListInstances {
    _private: (),
}
impl ListInstances {
    /// Creates a new builder-style object to manufacture [`ListInstancesInput`](crate::input::ListInstancesInput)
    pub fn builder() -> crate::input::list_instances_input::Builder {
        crate::input::list_instances_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListInstances {
    type Output =
        std::result::Result<crate::output::ListInstancesOutput, crate::error::ListInstancesError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_instances_error(response)
        } else {
            crate::operation_deser::parse_list_instances_response(response)
        }
    }
}

/// <p>Provides summaries of all notebook executions. You can filter the list based on multiple
/// criteria such as status, time range, and editor id. Returns a maximum of 50 notebook
/// executions and a marker to track the paging of a longer notebook execution list across
/// multiple <code>ListNotebookExecution</code> calls.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListNotebookExecutions {
    _private: (),
}
impl ListNotebookExecutions {
    /// Creates a new builder-style object to manufacture [`ListNotebookExecutionsInput`](crate::input::ListNotebookExecutionsInput)
    pub fn builder() -> crate::input::list_notebook_executions_input::Builder {
        crate::input::list_notebook_executions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListNotebookExecutions {
    type Output = std::result::Result<
        crate::output::ListNotebookExecutionsOutput,
        crate::error::ListNotebookExecutionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_notebook_executions_error(response)
        } else {
            crate::operation_deser::parse_list_notebook_executions_response(response)
        }
    }
}

/// <p>Retrieves release labels of EMR services in the region where the API is called.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListReleaseLabels {
    _private: (),
}
impl ListReleaseLabels {
    /// Creates a new builder-style object to manufacture [`ListReleaseLabelsInput`](crate::input::ListReleaseLabelsInput)
    pub fn builder() -> crate::input::list_release_labels_input::Builder {
        crate::input::list_release_labels_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListReleaseLabels {
    type Output = std::result::Result<
        crate::output::ListReleaseLabelsOutput,
        crate::error::ListReleaseLabelsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_release_labels_error(response)
        } else {
            crate::operation_deser::parse_list_release_labels_response(response)
        }
    }
}

/// <p>Lists all the security configurations visible to this account, providing their creation
/// dates and times, and their names. This call returns a maximum of 50 clusters per call, but
/// returns a marker to track the paging of the cluster list across multiple
/// ListSecurityConfigurations calls.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListSecurityConfigurations {
    _private: (),
}
impl ListSecurityConfigurations {
    /// Creates a new builder-style object to manufacture [`ListSecurityConfigurationsInput`](crate::input::ListSecurityConfigurationsInput)
    pub fn builder() -> crate::input::list_security_configurations_input::Builder {
        crate::input::list_security_configurations_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListSecurityConfigurations {
    type Output = std::result::Result<
        crate::output::ListSecurityConfigurationsOutput,
        crate::error::ListSecurityConfigurationsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_security_configurations_error(response)
        } else {
            crate::operation_deser::parse_list_security_configurations_response(response)
        }
    }
}

/// <p>Provides a list of steps for the cluster in reverse order unless you specify
/// <code>stepIds</code> with the request or filter by <code>StepStates</code>. You can
/// specify a maximum of 10 <code>stepIDs</code>. The CLI automatically paginates results to return a list greater than 50 steps. To return more than 50 steps using the CLI, specify a <code>Marker</code>, which is a pagination token that indicates the next set of steps to retrieve.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListSteps {
    _private: (),
}
impl ListSteps {
    /// Creates a new builder-style object to manufacture [`ListStepsInput`](crate::input::ListStepsInput)
    pub fn builder() -> crate::input::list_steps_input::Builder {
        crate::input::list_steps_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListSteps {
    type Output = std::result::Result<crate::output::ListStepsOutput, crate::error::ListStepsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_steps_error(response)
        } else {
            crate::operation_deser::parse_list_steps_response(response)
        }
    }
}

/// <p>Returns a list of all Amazon EMR Studios associated with the account. The list
/// includes details such as ID, Studio Access URL, and creation time for each Studio.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListStudios {
    _private: (),
}
impl ListStudios {
    /// Creates a new builder-style object to manufacture [`ListStudiosInput`](crate::input::ListStudiosInput)
    pub fn builder() -> crate::input::list_studios_input::Builder {
        crate::input::list_studios_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListStudios {
    type Output =
        std::result::Result<crate::output::ListStudiosOutput, crate::error::ListStudiosError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_studios_error(response)
        } else {
            crate::operation_deser::parse_list_studios_response(response)
        }
    }
}

/// <p>Returns a list of all user or group session mappings for the Amazon EMR Studio specified by
/// <code>StudioId</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListStudioSessionMappings {
    _private: (),
}
impl ListStudioSessionMappings {
    /// Creates a new builder-style object to manufacture [`ListStudioSessionMappingsInput`](crate::input::ListStudioSessionMappingsInput)
    pub fn builder() -> crate::input::list_studio_session_mappings_input::Builder {
        crate::input::list_studio_session_mappings_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListStudioSessionMappings {
    type Output = std::result::Result<
        crate::output::ListStudioSessionMappingsOutput,
        crate::error::ListStudioSessionMappingsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_studio_session_mappings_error(response)
        } else {
            crate::operation_deser::parse_list_studio_session_mappings_response(response)
        }
    }
}

/// <p>Modifies the number of steps that can be executed concurrently for the cluster specified
/// using ClusterID.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyCluster {
    _private: (),
}
impl ModifyCluster {
    /// Creates a new builder-style object to manufacture [`ModifyClusterInput`](crate::input::ModifyClusterInput)
    pub fn builder() -> crate::input::modify_cluster_input::Builder {
        crate::input::modify_cluster_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyCluster {
    type Output =
        std::result::Result<crate::output::ModifyClusterOutput, crate::error::ModifyClusterError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_cluster_error(response)
        } else {
            crate::operation_deser::parse_modify_cluster_response(response)
        }
    }
}

/// <p>Modifies the target On-Demand and target Spot capacities for the instance fleet with the
/// specified InstanceFleetID within the cluster specified using ClusterID. The call either
/// succeeds or fails atomically.</p>
/// <note>
/// <p>The instance fleet configuration is available only in Amazon EMR versions 4.8.0 and
/// later, excluding 5.0.x versions.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyInstanceFleet {
    _private: (),
}
impl ModifyInstanceFleet {
    /// Creates a new builder-style object to manufacture [`ModifyInstanceFleetInput`](crate::input::ModifyInstanceFleetInput)
    pub fn builder() -> crate::input::modify_instance_fleet_input::Builder {
        crate::input::modify_instance_fleet_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyInstanceFleet {
    type Output = std::result::Result<
        crate::output::ModifyInstanceFleetOutput,
        crate::error::ModifyInstanceFleetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_instance_fleet_error(response)
        } else {
            crate::operation_deser::parse_modify_instance_fleet_response(response)
        }
    }
}

/// <p>ModifyInstanceGroups modifies the number of nodes and configuration settings of an
/// instance group. The input parameters include the new target instance count for the group
/// and the instance group ID. The call will either succeed or fail atomically.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ModifyInstanceGroups {
    _private: (),
}
impl ModifyInstanceGroups {
    /// Creates a new builder-style object to manufacture [`ModifyInstanceGroupsInput`](crate::input::ModifyInstanceGroupsInput)
    pub fn builder() -> crate::input::modify_instance_groups_input::Builder {
        crate::input::modify_instance_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ModifyInstanceGroups {
    type Output = std::result::Result<
        crate::output::ModifyInstanceGroupsOutput,
        crate::error::ModifyInstanceGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_modify_instance_groups_error(response)
        } else {
            crate::operation_deser::parse_modify_instance_groups_response(response)
        }
    }
}

/// <p>Creates or updates an automatic scaling policy for a core instance group or task
/// instance group in an Amazon EMR cluster. The automatic scaling policy defines how an
/// instance group dynamically adds and terminates EC2 instances in response to the value of a
/// CloudWatch metric.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutAutoScalingPolicy {
    _private: (),
}
impl PutAutoScalingPolicy {
    /// Creates a new builder-style object to manufacture [`PutAutoScalingPolicyInput`](crate::input::PutAutoScalingPolicyInput)
    pub fn builder() -> crate::input::put_auto_scaling_policy_input::Builder {
        crate::input::put_auto_scaling_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutAutoScalingPolicy {
    type Output = std::result::Result<
        crate::output::PutAutoScalingPolicyOutput,
        crate::error::PutAutoScalingPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_auto_scaling_policy_error(response)
        } else {
            crate::operation_deser::parse_put_auto_scaling_policy_response(response)
        }
    }
}

/// <p>Creates or updates an Amazon EMR block public access configuration for your account
/// in the current Region. For more information see <a href="https://docs.aws.amazon.com/emr/latest/ManagementGuide/configure-block-public-access.html">Configure Block
/// Public Access for Amazon EMR</a> in the <i>Amazon EMR Management
/// Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutBlockPublicAccessConfiguration {
    _private: (),
}
impl PutBlockPublicAccessConfiguration {
    /// Creates a new builder-style object to manufacture [`PutBlockPublicAccessConfigurationInput`](crate::input::PutBlockPublicAccessConfigurationInput)
    pub fn builder() -> crate::input::put_block_public_access_configuration_input::Builder {
        crate::input::put_block_public_access_configuration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutBlockPublicAccessConfiguration {
    type Output = std::result::Result<
        crate::output::PutBlockPublicAccessConfigurationOutput,
        crate::error::PutBlockPublicAccessConfigurationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_block_public_access_configuration_error(response)
        } else {
            crate::operation_deser::parse_put_block_public_access_configuration_response(response)
        }
    }
}

/// <p>Creates or updates a managed scaling policy for an Amazon EMR cluster. The managed
/// scaling policy defines the limits for resources, such as EC2 instances that can be added or
/// terminated from a cluster. The policy only applies to the core and task nodes. The master
/// node cannot be scaled after initial configuration. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutManagedScalingPolicy {
    _private: (),
}
impl PutManagedScalingPolicy {
    /// Creates a new builder-style object to manufacture [`PutManagedScalingPolicyInput`](crate::input::PutManagedScalingPolicyInput)
    pub fn builder() -> crate::input::put_managed_scaling_policy_input::Builder {
        crate::input::put_managed_scaling_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutManagedScalingPolicy {
    type Output = std::result::Result<
        crate::output::PutManagedScalingPolicyOutput,
        crate::error::PutManagedScalingPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_managed_scaling_policy_error(response)
        } else {
            crate::operation_deser::parse_put_managed_scaling_policy_response(response)
        }
    }
}

/// <p>Removes an automatic scaling policy from a specified instance group within an EMR
/// cluster.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RemoveAutoScalingPolicy {
    _private: (),
}
impl RemoveAutoScalingPolicy {
    /// Creates a new builder-style object to manufacture [`RemoveAutoScalingPolicyInput`](crate::input::RemoveAutoScalingPolicyInput)
    pub fn builder() -> crate::input::remove_auto_scaling_policy_input::Builder {
        crate::input::remove_auto_scaling_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RemoveAutoScalingPolicy {
    type Output = std::result::Result<
        crate::output::RemoveAutoScalingPolicyOutput,
        crate::error::RemoveAutoScalingPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_remove_auto_scaling_policy_error(response)
        } else {
            crate::operation_deser::parse_remove_auto_scaling_policy_response(response)
        }
    }
}

/// <p> Removes a managed scaling policy from a specified EMR cluster. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RemoveManagedScalingPolicy {
    _private: (),
}
impl RemoveManagedScalingPolicy {
    /// Creates a new builder-style object to manufacture [`RemoveManagedScalingPolicyInput`](crate::input::RemoveManagedScalingPolicyInput)
    pub fn builder() -> crate::input::remove_managed_scaling_policy_input::Builder {
        crate::input::remove_managed_scaling_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RemoveManagedScalingPolicy {
    type Output = std::result::Result<
        crate::output::RemoveManagedScalingPolicyOutput,
        crate::error::RemoveManagedScalingPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_remove_managed_scaling_policy_error(response)
        } else {
            crate::operation_deser::parse_remove_managed_scaling_policy_response(response)
        }
    }
}

/// <p>Removes tags from an Amazon EMR resource. Tags make it easier to associate clusters in
/// various ways, such as grouping clusters to track your Amazon EMR resource allocation costs.
/// For more information, see <a href="https://docs.aws.amazon.com/emr/latest/ManagementGuide/emr-plan-tags.html">Tag Clusters</a>. </p>
/// <p>The following example removes the stack tag with value Prod from a cluster:</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RemoveTags {
    _private: (),
}
impl RemoveTags {
    /// Creates a new builder-style object to manufacture [`RemoveTagsInput`](crate::input::RemoveTagsInput)
    pub fn builder() -> crate::input::remove_tags_input::Builder {
        crate::input::remove_tags_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RemoveTags {
    type Output =
        std::result::Result<crate::output::RemoveTagsOutput, crate::error::RemoveTagsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_remove_tags_error(response)
        } else {
            crate::operation_deser::parse_remove_tags_response(response)
        }
    }
}

/// <p>RunJobFlow creates and starts running a new cluster (job flow). The cluster runs the
/// steps specified. After the steps complete, the cluster stops and the HDFS partition is
/// lost. To prevent loss of data, configure the last step of the job flow to store results in
/// Amazon S3. If the <a>JobFlowInstancesConfig</a>
/// <code>KeepJobFlowAliveWhenNoSteps</code> parameter is set to <code>TRUE</code>, the cluster
/// transitions to the WAITING state rather than shutting down after the steps have completed. </p>
/// <p>For additional protection, you can set the <a>JobFlowInstancesConfig</a>
/// <code>TerminationProtected</code> parameter to <code>TRUE</code> to lock the cluster and
/// prevent it from being terminated by API call, user intervention, or in the event of a job
/// flow error.</p>
/// <p>A maximum of 256 steps are allowed in each job flow.</p>
/// <p>If your cluster is long-running (such as a Hive data warehouse) or complex, you may
/// require more than 256 steps to process your data. You can bypass the 256-step limitation in
/// various ways, including using the SSH shell to connect to the master node and submitting
/// queries directly to the software running on the master node, such as Hive and Hadoop. For
/// more information on how to do this, see <a href="https://docs.aws.amazon.com/emr/latest/ManagementGuide/AddMoreThan256Steps.html">Add More than 256 Steps to a
/// Cluster</a> in the <i>Amazon EMR Management Guide</i>.</p>
/// <p>For long running clusters, we recommend that you periodically store your results.</p>
/// <note>
/// <p>The instance fleets configuration is available only in Amazon EMR versions 4.8.0 and
/// later, excluding 5.0.x versions. The RunJobFlow request can contain InstanceFleets
/// parameters or InstanceGroups parameters, but not both.</p>
/// </note>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RunJobFlow {
    _private: (),
}
impl RunJobFlow {
    /// Creates a new builder-style object to manufacture [`RunJobFlowInput`](crate::input::RunJobFlowInput)
    pub fn builder() -> crate::input::run_job_flow_input::Builder {
        crate::input::run_job_flow_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RunJobFlow {
    type Output =
        std::result::Result<crate::output::RunJobFlowOutput, crate::error::RunJobFlowError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_run_job_flow_error(response)
        } else {
            crate::operation_deser::parse_run_job_flow_response(response)
        }
    }
}

/// <p>SetTerminationProtection locks a cluster (job flow) so the EC2 instances in the cluster
/// cannot be terminated by user intervention, an API call, or in the event of a job-flow
/// error. The cluster still terminates upon successful completion of the job flow. Calling
/// <code>SetTerminationProtection</code> on a cluster is similar to calling the Amazon EC2
/// <code>DisableAPITermination</code> API on all EC2 instances in a cluster.</p>
/// <p>
/// <code>SetTerminationProtection</code> is used to prevent accidental termination of a
/// cluster and to ensure that in the event of an error, the instances persist so that you can
/// recover any data stored in their ephemeral instance storage.</p>
/// <p> To terminate a cluster that has been locked by setting
/// <code>SetTerminationProtection</code> to <code>true</code>, you must first unlock the
/// job flow by a subsequent call to <code>SetTerminationProtection</code> in which you set the
/// value to <code>false</code>. </p>
/// <p> For more information, see<a href="https://docs.aws.amazon.com/emr/latest/ManagementGuide/UsingEMR_TerminationProtection.html">Managing Cluster
/// Termination</a> in the <i>Amazon EMR Management Guide</i>. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SetTerminationProtection {
    _private: (),
}
impl SetTerminationProtection {
    /// Creates a new builder-style object to manufacture [`SetTerminationProtectionInput`](crate::input::SetTerminationProtectionInput)
    pub fn builder() -> crate::input::set_termination_protection_input::Builder {
        crate::input::set_termination_protection_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SetTerminationProtection {
    type Output = std::result::Result<
        crate::output::SetTerminationProtectionOutput,
        crate::error::SetTerminationProtectionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_set_termination_protection_error(response)
        } else {
            crate::operation_deser::parse_set_termination_protection_response(response)
        }
    }
}

/// <p>Sets the <a>Cluster$VisibleToAllUsers</a> value for an EMR cluster. When <code>true</code>, IAM principals in the
/// account can perform EMR cluster actions that their IAM policies allow. When <code>false</code>, only the IAM principal that created the cluster and the account root user can perform EMR actions on the cluster, regardless of IAM permissions policies attached to other IAM principals.</p>
/// <p>This action works on running clusters. When you create a cluster, use the <a>RunJobFlowInput$VisibleToAllUsers</a> parameter.</p>
/// <p>For more information, see <a href="https://docs.aws.amazon.com/emr/latest/ManagementGuide/security_iam_emr-with-iam.html#security_set_visible_to_all_users">Understanding the EMR Cluster VisibleToAllUsers Setting</a> in the <i>Amazon EMRManagement Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SetVisibleToAllUsers {
    _private: (),
}
impl SetVisibleToAllUsers {
    /// Creates a new builder-style object to manufacture [`SetVisibleToAllUsersInput`](crate::input::SetVisibleToAllUsersInput)
    pub fn builder() -> crate::input::set_visible_to_all_users_input::Builder {
        crate::input::set_visible_to_all_users_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SetVisibleToAllUsers {
    type Output = std::result::Result<
        crate::output::SetVisibleToAllUsersOutput,
        crate::error::SetVisibleToAllUsersError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_set_visible_to_all_users_error(response)
        } else {
            crate::operation_deser::parse_set_visible_to_all_users_response(response)
        }
    }
}

/// <p>Starts a notebook execution.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct StartNotebookExecution {
    _private: (),
}
impl StartNotebookExecution {
    /// Creates a new builder-style object to manufacture [`StartNotebookExecutionInput`](crate::input::StartNotebookExecutionInput)
    pub fn builder() -> crate::input::start_notebook_execution_input::Builder {
        crate::input::start_notebook_execution_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for StartNotebookExecution {
    type Output = std::result::Result<
        crate::output::StartNotebookExecutionOutput,
        crate::error::StartNotebookExecutionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_start_notebook_execution_error(response)
        } else {
            crate::operation_deser::parse_start_notebook_execution_response(response)
        }
    }
}

/// <p>Stops a notebook execution.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct StopNotebookExecution {
    _private: (),
}
impl StopNotebookExecution {
    /// Creates a new builder-style object to manufacture [`StopNotebookExecutionInput`](crate::input::StopNotebookExecutionInput)
    pub fn builder() -> crate::input::stop_notebook_execution_input::Builder {
        crate::input::stop_notebook_execution_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for StopNotebookExecution {
    type Output = std::result::Result<
        crate::output::StopNotebookExecutionOutput,
        crate::error::StopNotebookExecutionError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_stop_notebook_execution_error(response)
        } else {
            crate::operation_deser::parse_stop_notebook_execution_response(response)
        }
    }
}

/// <p>TerminateJobFlows shuts a list of clusters (job flows) down. When a job flow is shut
/// down, any step not yet completed is canceled and the EC2 instances on which the cluster is
/// running are stopped. Any log files not already saved are uploaded to Amazon S3 if a LogUri
/// was specified when the cluster was created.</p>
/// <p>The maximum number of clusters allowed is 10. The call to <code>TerminateJobFlows</code>
/// is asynchronous. Depending on the configuration of the cluster, it may take up to 1-5
/// minutes for the cluster to completely terminate and release allocated resources, such as
/// Amazon EC2 instances.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TerminateJobFlows {
    _private: (),
}
impl TerminateJobFlows {
    /// Creates a new builder-style object to manufacture [`TerminateJobFlowsInput`](crate::input::TerminateJobFlowsInput)
    pub fn builder() -> crate::input::terminate_job_flows_input::Builder {
        crate::input::terminate_job_flows_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TerminateJobFlows {
    type Output = std::result::Result<
        crate::output::TerminateJobFlowsOutput,
        crate::error::TerminateJobFlowsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_terminate_job_flows_error(response)
        } else {
            crate::operation_deser::parse_terminate_job_flows_response(response)
        }
    }
}

/// <p>Updates an Amazon EMR Studio configuration, including attributes such as name, description, and subnets.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateStudio {
    _private: (),
}
impl UpdateStudio {
    /// Creates a new builder-style object to manufacture [`UpdateStudioInput`](crate::input::UpdateStudioInput)
    pub fn builder() -> crate::input::update_studio_input::Builder {
        crate::input::update_studio_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateStudio {
    type Output =
        std::result::Result<crate::output::UpdateStudioOutput, crate::error::UpdateStudioError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_studio_error(response)
        } else {
            crate::operation_deser::parse_update_studio_response(response)
        }
    }
}

/// <p>Updates the session policy attached to the user or group for the specified Amazon EMR
/// Studio.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateStudioSessionMapping {
    _private: (),
}
impl UpdateStudioSessionMapping {
    /// Creates a new builder-style object to manufacture [`UpdateStudioSessionMappingInput`](crate::input::UpdateStudioSessionMappingInput)
    pub fn builder() -> crate::input::update_studio_session_mapping_input::Builder {
        crate::input::update_studio_session_mapping_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateStudioSessionMapping {
    type Output = std::result::Result<
        crate::output::UpdateStudioSessionMappingOutput,
        crate::error::UpdateStudioSessionMappingError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_studio_session_mapping_error(response)
        } else {
            crate::operation_deser::parse_update_studio_session_mapping_response(response)
        }
    }
}
