// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <p>Assigns attributes (key and value pairs) to the findings that are specified by the
/// ARNs of the findings.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct AddAttributesToFindings {
    _private: (),
}
impl AddAttributesToFindings {
    /// Creates a new builder-style object to manufacture [`AddAttributesToFindingsInput`](crate::input::AddAttributesToFindingsInput)
    pub fn builder() -> crate::input::add_attributes_to_findings_input::Builder {
        crate::input::add_attributes_to_findings_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for AddAttributesToFindings {
    type Output = std::result::Result<
        crate::output::AddAttributesToFindingsOutput,
        crate::error::AddAttributesToFindingsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_add_attributes_to_findings_error(response)
        } else {
            crate::operation_deser::parse_add_attributes_to_findings_response(response)
        }
    }
}

/// <p>Creates a new assessment target using the ARN of the resource group that is generated
/// by <a>CreateResourceGroup</a>. If resourceGroupArn is not specified, all EC2
/// instances in the current AWS account and region are included in the assessment target. If
/// the <a href="https://docs.aws.amazon.com/inspector/latest/userguide/inspector_slr.html">service-linked role</a> isn’t already registered, this action also creates and
/// registers a service-linked role to grant Amazon Inspector access to AWS Services needed to
/// perform security assessments. You can create up to 50 assessment targets per AWS account.
/// You can run up to 500 concurrent agents per AWS account. For more information, see <a href="https://docs.aws.amazon.com/inspector/latest/userguide/inspector_applications.html">
/// Amazon Inspector Assessment Targets</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateAssessmentTarget {
    _private: (),
}
impl CreateAssessmentTarget {
    /// Creates a new builder-style object to manufacture [`CreateAssessmentTargetInput`](crate::input::CreateAssessmentTargetInput)
    pub fn builder() -> crate::input::create_assessment_target_input::Builder {
        crate::input::create_assessment_target_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateAssessmentTarget {
    type Output = std::result::Result<
        crate::output::CreateAssessmentTargetOutput,
        crate::error::CreateAssessmentTargetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_assessment_target_error(response)
        } else {
            crate::operation_deser::parse_create_assessment_target_response(response)
        }
    }
}

/// <p>Creates an assessment template for the assessment target that is specified by the ARN
/// of the assessment target. If the <a href="https://docs.aws.amazon.com/inspector/latest/userguide/inspector_slr.html">service-linked role</a> isn’t already registered, this action also creates and
/// registers a service-linked role to grant Amazon Inspector access to AWS Services needed to
/// perform security assessments.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateAssessmentTemplate {
    _private: (),
}
impl CreateAssessmentTemplate {
    /// Creates a new builder-style object to manufacture [`CreateAssessmentTemplateInput`](crate::input::CreateAssessmentTemplateInput)
    pub fn builder() -> crate::input::create_assessment_template_input::Builder {
        crate::input::create_assessment_template_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateAssessmentTemplate {
    type Output = std::result::Result<
        crate::output::CreateAssessmentTemplateOutput,
        crate::error::CreateAssessmentTemplateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_assessment_template_error(response)
        } else {
            crate::operation_deser::parse_create_assessment_template_response(response)
        }
    }
}

/// <p>Starts the generation of an exclusions preview for the specified assessment template.
/// The exclusions preview lists the potential exclusions (ExclusionPreview) that Inspector can
/// detect before it runs the assessment. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateExclusionsPreview {
    _private: (),
}
impl CreateExclusionsPreview {
    /// Creates a new builder-style object to manufacture [`CreateExclusionsPreviewInput`](crate::input::CreateExclusionsPreviewInput)
    pub fn builder() -> crate::input::create_exclusions_preview_input::Builder {
        crate::input::create_exclusions_preview_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateExclusionsPreview {
    type Output = std::result::Result<
        crate::output::CreateExclusionsPreviewOutput,
        crate::error::CreateExclusionsPreviewError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_exclusions_preview_error(response)
        } else {
            crate::operation_deser::parse_create_exclusions_preview_response(response)
        }
    }
}

/// <p>Creates a resource group using the specified set of tags (key and value pairs) that
/// are used to select the EC2 instances to be included in an Amazon Inspector assessment
/// target. The created resource group is then used to create an Amazon Inspector assessment
/// target. For more information, see <a>CreateAssessmentTarget</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateResourceGroup {
    _private: (),
}
impl CreateResourceGroup {
    /// Creates a new builder-style object to manufacture [`CreateResourceGroupInput`](crate::input::CreateResourceGroupInput)
    pub fn builder() -> crate::input::create_resource_group_input::Builder {
        crate::input::create_resource_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateResourceGroup {
    type Output = std::result::Result<
        crate::output::CreateResourceGroupOutput,
        crate::error::CreateResourceGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_resource_group_error(response)
        } else {
            crate::operation_deser::parse_create_resource_group_response(response)
        }
    }
}

/// <p>Deletes the assessment run that is specified by the ARN of the assessment
/// run.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteAssessmentRun {
    _private: (),
}
impl DeleteAssessmentRun {
    /// Creates a new builder-style object to manufacture [`DeleteAssessmentRunInput`](crate::input::DeleteAssessmentRunInput)
    pub fn builder() -> crate::input::delete_assessment_run_input::Builder {
        crate::input::delete_assessment_run_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteAssessmentRun {
    type Output = std::result::Result<
        crate::output::DeleteAssessmentRunOutput,
        crate::error::DeleteAssessmentRunError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_assessment_run_error(response)
        } else {
            crate::operation_deser::parse_delete_assessment_run_response(response)
        }
    }
}

/// <p>Deletes the assessment target that is specified by the ARN of the assessment
/// target.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteAssessmentTarget {
    _private: (),
}
impl DeleteAssessmentTarget {
    /// Creates a new builder-style object to manufacture [`DeleteAssessmentTargetInput`](crate::input::DeleteAssessmentTargetInput)
    pub fn builder() -> crate::input::delete_assessment_target_input::Builder {
        crate::input::delete_assessment_target_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteAssessmentTarget {
    type Output = std::result::Result<
        crate::output::DeleteAssessmentTargetOutput,
        crate::error::DeleteAssessmentTargetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_assessment_target_error(response)
        } else {
            crate::operation_deser::parse_delete_assessment_target_response(response)
        }
    }
}

/// <p>Deletes the assessment template that is specified by the ARN of the assessment
/// template.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteAssessmentTemplate {
    _private: (),
}
impl DeleteAssessmentTemplate {
    /// Creates a new builder-style object to manufacture [`DeleteAssessmentTemplateInput`](crate::input::DeleteAssessmentTemplateInput)
    pub fn builder() -> crate::input::delete_assessment_template_input::Builder {
        crate::input::delete_assessment_template_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteAssessmentTemplate {
    type Output = std::result::Result<
        crate::output::DeleteAssessmentTemplateOutput,
        crate::error::DeleteAssessmentTemplateError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_assessment_template_error(response)
        } else {
            crate::operation_deser::parse_delete_assessment_template_response(response)
        }
    }
}

/// <p>Describes the assessment runs that are specified by the ARNs of the assessment
/// runs.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeAssessmentRuns {
    _private: (),
}
impl DescribeAssessmentRuns {
    /// Creates a new builder-style object to manufacture [`DescribeAssessmentRunsInput`](crate::input::DescribeAssessmentRunsInput)
    pub fn builder() -> crate::input::describe_assessment_runs_input::Builder {
        crate::input::describe_assessment_runs_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeAssessmentRuns {
    type Output = std::result::Result<
        crate::output::DescribeAssessmentRunsOutput,
        crate::error::DescribeAssessmentRunsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_assessment_runs_error(response)
        } else {
            crate::operation_deser::parse_describe_assessment_runs_response(response)
        }
    }
}

/// <p>Describes the assessment targets that are specified by the ARNs of the assessment
/// targets.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeAssessmentTargets {
    _private: (),
}
impl DescribeAssessmentTargets {
    /// Creates a new builder-style object to manufacture [`DescribeAssessmentTargetsInput`](crate::input::DescribeAssessmentTargetsInput)
    pub fn builder() -> crate::input::describe_assessment_targets_input::Builder {
        crate::input::describe_assessment_targets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeAssessmentTargets {
    type Output = std::result::Result<
        crate::output::DescribeAssessmentTargetsOutput,
        crate::error::DescribeAssessmentTargetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_assessment_targets_error(response)
        } else {
            crate::operation_deser::parse_describe_assessment_targets_response(response)
        }
    }
}

/// <p>Describes the assessment templates that are specified by the ARNs of the assessment
/// templates.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeAssessmentTemplates {
    _private: (),
}
impl DescribeAssessmentTemplates {
    /// Creates a new builder-style object to manufacture [`DescribeAssessmentTemplatesInput`](crate::input::DescribeAssessmentTemplatesInput)
    pub fn builder() -> crate::input::describe_assessment_templates_input::Builder {
        crate::input::describe_assessment_templates_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeAssessmentTemplates {
    type Output = std::result::Result<
        crate::output::DescribeAssessmentTemplatesOutput,
        crate::error::DescribeAssessmentTemplatesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_assessment_templates_error(response)
        } else {
            crate::operation_deser::parse_describe_assessment_templates_response(response)
        }
    }
}

/// <p>Describes the IAM role that enables Amazon Inspector to access your AWS
/// account.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeCrossAccountAccessRole {
    _private: (),
}
impl DescribeCrossAccountAccessRole {
    /// Creates a new builder-style object to manufacture [`DescribeCrossAccountAccessRoleInput`](crate::input::DescribeCrossAccountAccessRoleInput)
    pub fn builder() -> crate::input::describe_cross_account_access_role_input::Builder {
        crate::input::describe_cross_account_access_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeCrossAccountAccessRole {
    type Output = std::result::Result<
        crate::output::DescribeCrossAccountAccessRoleOutput,
        crate::error::DescribeCrossAccountAccessRoleError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_cross_account_access_role_error(response)
        } else {
            crate::operation_deser::parse_describe_cross_account_access_role_response(response)
        }
    }
}

/// <p>Describes the exclusions that are specified by the exclusions' ARNs.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeExclusions {
    _private: (),
}
impl DescribeExclusions {
    /// Creates a new builder-style object to manufacture [`DescribeExclusionsInput`](crate::input::DescribeExclusionsInput)
    pub fn builder() -> crate::input::describe_exclusions_input::Builder {
        crate::input::describe_exclusions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeExclusions {
    type Output = std::result::Result<
        crate::output::DescribeExclusionsOutput,
        crate::error::DescribeExclusionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_exclusions_error(response)
        } else {
            crate::operation_deser::parse_describe_exclusions_response(response)
        }
    }
}

/// <p>Describes the findings that are specified by the ARNs of the findings.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeFindings {
    _private: (),
}
impl DescribeFindings {
    /// Creates a new builder-style object to manufacture [`DescribeFindingsInput`](crate::input::DescribeFindingsInput)
    pub fn builder() -> crate::input::describe_findings_input::Builder {
        crate::input::describe_findings_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeFindings {
    type Output = std::result::Result<
        crate::output::DescribeFindingsOutput,
        crate::error::DescribeFindingsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_findings_error(response)
        } else {
            crate::operation_deser::parse_describe_findings_response(response)
        }
    }
}

/// <p>Describes the resource groups that are specified by the ARNs of the resource
/// groups.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeResourceGroups {
    _private: (),
}
impl DescribeResourceGroups {
    /// Creates a new builder-style object to manufacture [`DescribeResourceGroupsInput`](crate::input::DescribeResourceGroupsInput)
    pub fn builder() -> crate::input::describe_resource_groups_input::Builder {
        crate::input::describe_resource_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeResourceGroups {
    type Output = std::result::Result<
        crate::output::DescribeResourceGroupsOutput,
        crate::error::DescribeResourceGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_resource_groups_error(response)
        } else {
            crate::operation_deser::parse_describe_resource_groups_response(response)
        }
    }
}

/// <p>Describes the rules packages that are specified by the ARNs of the rules
/// packages.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DescribeRulesPackages {
    _private: (),
}
impl DescribeRulesPackages {
    /// Creates a new builder-style object to manufacture [`DescribeRulesPackagesInput`](crate::input::DescribeRulesPackagesInput)
    pub fn builder() -> crate::input::describe_rules_packages_input::Builder {
        crate::input::describe_rules_packages_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DescribeRulesPackages {
    type Output = std::result::Result<
        crate::output::DescribeRulesPackagesOutput,
        crate::error::DescribeRulesPackagesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_describe_rules_packages_error(response)
        } else {
            crate::operation_deser::parse_describe_rules_packages_response(response)
        }
    }
}

/// <p>Produces an assessment report that includes detailed and comprehensive results of a
/// specified assessment run. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetAssessmentReport {
    _private: (),
}
impl GetAssessmentReport {
    /// Creates a new builder-style object to manufacture [`GetAssessmentReportInput`](crate::input::GetAssessmentReportInput)
    pub fn builder() -> crate::input::get_assessment_report_input::Builder {
        crate::input::get_assessment_report_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetAssessmentReport {
    type Output = std::result::Result<
        crate::output::GetAssessmentReportOutput,
        crate::error::GetAssessmentReportError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_assessment_report_error(response)
        } else {
            crate::operation_deser::parse_get_assessment_report_response(response)
        }
    }
}

/// <p>Retrieves the exclusions preview (a list of ExclusionPreview objects) specified by
/// the preview token. You can obtain the preview token by running the CreateExclusionsPreview
/// API.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetExclusionsPreview {
    _private: (),
}
impl GetExclusionsPreview {
    /// Creates a new builder-style object to manufacture [`GetExclusionsPreviewInput`](crate::input::GetExclusionsPreviewInput)
    pub fn builder() -> crate::input::get_exclusions_preview_input::Builder {
        crate::input::get_exclusions_preview_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetExclusionsPreview {
    type Output = std::result::Result<
        crate::output::GetExclusionsPreviewOutput,
        crate::error::GetExclusionsPreviewError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_exclusions_preview_error(response)
        } else {
            crate::operation_deser::parse_get_exclusions_preview_response(response)
        }
    }
}

/// <p>Information about the data that is collected for the specified assessment
/// run.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetTelemetryMetadata {
    _private: (),
}
impl GetTelemetryMetadata {
    /// Creates a new builder-style object to manufacture [`GetTelemetryMetadataInput`](crate::input::GetTelemetryMetadataInput)
    pub fn builder() -> crate::input::get_telemetry_metadata_input::Builder {
        crate::input::get_telemetry_metadata_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetTelemetryMetadata {
    type Output = std::result::Result<
        crate::output::GetTelemetryMetadataOutput,
        crate::error::GetTelemetryMetadataError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_telemetry_metadata_error(response)
        } else {
            crate::operation_deser::parse_get_telemetry_metadata_response(response)
        }
    }
}

/// <p>Lists the agents of the assessment runs that are specified by the ARNs of the
/// assessment runs.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAssessmentRunAgents {
    _private: (),
}
impl ListAssessmentRunAgents {
    /// Creates a new builder-style object to manufacture [`ListAssessmentRunAgentsInput`](crate::input::ListAssessmentRunAgentsInput)
    pub fn builder() -> crate::input::list_assessment_run_agents_input::Builder {
        crate::input::list_assessment_run_agents_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAssessmentRunAgents {
    type Output = std::result::Result<
        crate::output::ListAssessmentRunAgentsOutput,
        crate::error::ListAssessmentRunAgentsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_assessment_run_agents_error(response)
        } else {
            crate::operation_deser::parse_list_assessment_run_agents_response(response)
        }
    }
}

/// <p>Lists the assessment runs that correspond to the assessment templates that are
/// specified by the ARNs of the assessment templates.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAssessmentRuns {
    _private: (),
}
impl ListAssessmentRuns {
    /// Creates a new builder-style object to manufacture [`ListAssessmentRunsInput`](crate::input::ListAssessmentRunsInput)
    pub fn builder() -> crate::input::list_assessment_runs_input::Builder {
        crate::input::list_assessment_runs_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAssessmentRuns {
    type Output = std::result::Result<
        crate::output::ListAssessmentRunsOutput,
        crate::error::ListAssessmentRunsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_assessment_runs_error(response)
        } else {
            crate::operation_deser::parse_list_assessment_runs_response(response)
        }
    }
}

/// <p>Lists the ARNs of the assessment targets within this AWS account. For more
/// information about assessment targets, see <a href="https://docs.aws.amazon.com/inspector/latest/userguide/inspector_applications.html">Amazon Inspector Assessment
/// Targets</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAssessmentTargets {
    _private: (),
}
impl ListAssessmentTargets {
    /// Creates a new builder-style object to manufacture [`ListAssessmentTargetsInput`](crate::input::ListAssessmentTargetsInput)
    pub fn builder() -> crate::input::list_assessment_targets_input::Builder {
        crate::input::list_assessment_targets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAssessmentTargets {
    type Output = std::result::Result<
        crate::output::ListAssessmentTargetsOutput,
        crate::error::ListAssessmentTargetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_assessment_targets_error(response)
        } else {
            crate::operation_deser::parse_list_assessment_targets_response(response)
        }
    }
}

/// <p>Lists the assessment templates that correspond to the assessment targets that are
/// specified by the ARNs of the assessment targets.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListAssessmentTemplates {
    _private: (),
}
impl ListAssessmentTemplates {
    /// Creates a new builder-style object to manufacture [`ListAssessmentTemplatesInput`](crate::input::ListAssessmentTemplatesInput)
    pub fn builder() -> crate::input::list_assessment_templates_input::Builder {
        crate::input::list_assessment_templates_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListAssessmentTemplates {
    type Output = std::result::Result<
        crate::output::ListAssessmentTemplatesOutput,
        crate::error::ListAssessmentTemplatesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_assessment_templates_error(response)
        } else {
            crate::operation_deser::parse_list_assessment_templates_response(response)
        }
    }
}

/// <p>Lists all the event subscriptions for the assessment template that is specified by
/// the ARN of the assessment template. For more information, see <a>SubscribeToEvent</a> and <a>UnsubscribeFromEvent</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListEventSubscriptions {
    _private: (),
}
impl ListEventSubscriptions {
    /// Creates a new builder-style object to manufacture [`ListEventSubscriptionsInput`](crate::input::ListEventSubscriptionsInput)
    pub fn builder() -> crate::input::list_event_subscriptions_input::Builder {
        crate::input::list_event_subscriptions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListEventSubscriptions {
    type Output = std::result::Result<
        crate::output::ListEventSubscriptionsOutput,
        crate::error::ListEventSubscriptionsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_event_subscriptions_error(response)
        } else {
            crate::operation_deser::parse_list_event_subscriptions_response(response)
        }
    }
}

/// <p>List exclusions that are generated by the assessment run.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListExclusions {
    _private: (),
}
impl ListExclusions {
    /// Creates a new builder-style object to manufacture [`ListExclusionsInput`](crate::input::ListExclusionsInput)
    pub fn builder() -> crate::input::list_exclusions_input::Builder {
        crate::input::list_exclusions_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListExclusions {
    type Output =
        std::result::Result<crate::output::ListExclusionsOutput, crate::error::ListExclusionsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_exclusions_error(response)
        } else {
            crate::operation_deser::parse_list_exclusions_response(response)
        }
    }
}

/// <p>Lists findings that are generated by the assessment runs that are specified by the
/// ARNs of the assessment runs.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListFindings {
    _private: (),
}
impl ListFindings {
    /// Creates a new builder-style object to manufacture [`ListFindingsInput`](crate::input::ListFindingsInput)
    pub fn builder() -> crate::input::list_findings_input::Builder {
        crate::input::list_findings_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListFindings {
    type Output =
        std::result::Result<crate::output::ListFindingsOutput, crate::error::ListFindingsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_findings_error(response)
        } else {
            crate::operation_deser::parse_list_findings_response(response)
        }
    }
}

/// <p>Lists all available Amazon Inspector rules packages.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListRulesPackages {
    _private: (),
}
impl ListRulesPackages {
    /// Creates a new builder-style object to manufacture [`ListRulesPackagesInput`](crate::input::ListRulesPackagesInput)
    pub fn builder() -> crate::input::list_rules_packages_input::Builder {
        crate::input::list_rules_packages_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListRulesPackages {
    type Output = std::result::Result<
        crate::output::ListRulesPackagesOutput,
        crate::error::ListRulesPackagesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_rules_packages_error(response)
        } else {
            crate::operation_deser::parse_list_rules_packages_response(response)
        }
    }
}

/// <p>Lists all tags associated with an assessment template.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListTagsForResource {
    _private: (),
}
impl ListTagsForResource {
    /// Creates a new builder-style object to manufacture [`ListTagsForResourceInput`](crate::input::ListTagsForResourceInput)
    pub fn builder() -> crate::input::list_tags_for_resource_input::Builder {
        crate::input::list_tags_for_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListTagsForResource {
    type Output = std::result::Result<
        crate::output::ListTagsForResourceOutput,
        crate::error::ListTagsForResourceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_tags_for_resource_error(response)
        } else {
            crate::operation_deser::parse_list_tags_for_resource_response(response)
        }
    }
}

/// <p>Previews the agents installed on the EC2 instances that are part of the specified
/// assessment target.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PreviewAgents {
    _private: (),
}
impl PreviewAgents {
    /// Creates a new builder-style object to manufacture [`PreviewAgentsInput`](crate::input::PreviewAgentsInput)
    pub fn builder() -> crate::input::preview_agents_input::Builder {
        crate::input::preview_agents_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PreviewAgents {
    type Output =
        std::result::Result<crate::output::PreviewAgentsOutput, crate::error::PreviewAgentsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_preview_agents_error(response)
        } else {
            crate::operation_deser::parse_preview_agents_response(response)
        }
    }
}

/// <p>Registers the IAM role that grants Amazon Inspector access to AWS Services needed to
/// perform security assessments.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RegisterCrossAccountAccessRole {
    _private: (),
}
impl RegisterCrossAccountAccessRole {
    /// Creates a new builder-style object to manufacture [`RegisterCrossAccountAccessRoleInput`](crate::input::RegisterCrossAccountAccessRoleInput)
    pub fn builder() -> crate::input::register_cross_account_access_role_input::Builder {
        crate::input::register_cross_account_access_role_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RegisterCrossAccountAccessRole {
    type Output = std::result::Result<
        crate::output::RegisterCrossAccountAccessRoleOutput,
        crate::error::RegisterCrossAccountAccessRoleError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_register_cross_account_access_role_error(response)
        } else {
            crate::operation_deser::parse_register_cross_account_access_role_response(response)
        }
    }
}

/// <p>Removes entire attributes (key and value pairs) from the findings that are specified
/// by the ARNs of the findings where an attribute with the specified key exists.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct RemoveAttributesFromFindings {
    _private: (),
}
impl RemoveAttributesFromFindings {
    /// Creates a new builder-style object to manufacture [`RemoveAttributesFromFindingsInput`](crate::input::RemoveAttributesFromFindingsInput)
    pub fn builder() -> crate::input::remove_attributes_from_findings_input::Builder {
        crate::input::remove_attributes_from_findings_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for RemoveAttributesFromFindings {
    type Output = std::result::Result<
        crate::output::RemoveAttributesFromFindingsOutput,
        crate::error::RemoveAttributesFromFindingsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_remove_attributes_from_findings_error(response)
        } else {
            crate::operation_deser::parse_remove_attributes_from_findings_response(response)
        }
    }
}

/// <p>Sets tags (key and value pairs) to the assessment template that is specified by the
/// ARN of the assessment template.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SetTagsForResource {
    _private: (),
}
impl SetTagsForResource {
    /// Creates a new builder-style object to manufacture [`SetTagsForResourceInput`](crate::input::SetTagsForResourceInput)
    pub fn builder() -> crate::input::set_tags_for_resource_input::Builder {
        crate::input::set_tags_for_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SetTagsForResource {
    type Output = std::result::Result<
        crate::output::SetTagsForResourceOutput,
        crate::error::SetTagsForResourceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_set_tags_for_resource_error(response)
        } else {
            crate::operation_deser::parse_set_tags_for_resource_response(response)
        }
    }
}

/// <p>Starts the assessment run specified by the ARN of the assessment template. For this
/// API to function properly, you must not exceed the limit of running up to 500 concurrent
/// agents per AWS account.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct StartAssessmentRun {
    _private: (),
}
impl StartAssessmentRun {
    /// Creates a new builder-style object to manufacture [`StartAssessmentRunInput`](crate::input::StartAssessmentRunInput)
    pub fn builder() -> crate::input::start_assessment_run_input::Builder {
        crate::input::start_assessment_run_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for StartAssessmentRun {
    type Output = std::result::Result<
        crate::output::StartAssessmentRunOutput,
        crate::error::StartAssessmentRunError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_start_assessment_run_error(response)
        } else {
            crate::operation_deser::parse_start_assessment_run_response(response)
        }
    }
}

/// <p>Stops the assessment run that is specified by the ARN of the assessment
/// run.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct StopAssessmentRun {
    _private: (),
}
impl StopAssessmentRun {
    /// Creates a new builder-style object to manufacture [`StopAssessmentRunInput`](crate::input::StopAssessmentRunInput)
    pub fn builder() -> crate::input::stop_assessment_run_input::Builder {
        crate::input::stop_assessment_run_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for StopAssessmentRun {
    type Output = std::result::Result<
        crate::output::StopAssessmentRunOutput,
        crate::error::StopAssessmentRunError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_stop_assessment_run_error(response)
        } else {
            crate::operation_deser::parse_stop_assessment_run_response(response)
        }
    }
}

/// <p>Enables the process of sending Amazon Simple Notification Service (SNS) notifications
/// about a specified event to a specified SNS topic.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct SubscribeToEvent {
    _private: (),
}
impl SubscribeToEvent {
    /// Creates a new builder-style object to manufacture [`SubscribeToEventInput`](crate::input::SubscribeToEventInput)
    pub fn builder() -> crate::input::subscribe_to_event_input::Builder {
        crate::input::subscribe_to_event_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for SubscribeToEvent {
    type Output = std::result::Result<
        crate::output::SubscribeToEventOutput,
        crate::error::SubscribeToEventError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_subscribe_to_event_error(response)
        } else {
            crate::operation_deser::parse_subscribe_to_event_response(response)
        }
    }
}

/// <p>Disables the process of sending Amazon Simple Notification Service (SNS)
/// notifications about a specified event to a specified SNS topic.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UnsubscribeFromEvent {
    _private: (),
}
impl UnsubscribeFromEvent {
    /// Creates a new builder-style object to manufacture [`UnsubscribeFromEventInput`](crate::input::UnsubscribeFromEventInput)
    pub fn builder() -> crate::input::unsubscribe_from_event_input::Builder {
        crate::input::unsubscribe_from_event_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UnsubscribeFromEvent {
    type Output = std::result::Result<
        crate::output::UnsubscribeFromEventOutput,
        crate::error::UnsubscribeFromEventError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_unsubscribe_from_event_error(response)
        } else {
            crate::operation_deser::parse_unsubscribe_from_event_response(response)
        }
    }
}

/// <p>Updates the assessment target that is specified by the ARN of the assessment
/// target.</p>
/// <p>If resourceGroupArn is not specified, all EC2 instances in the current AWS account
/// and region are included in the assessment target.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateAssessmentTarget {
    _private: (),
}
impl UpdateAssessmentTarget {
    /// Creates a new builder-style object to manufacture [`UpdateAssessmentTargetInput`](crate::input::UpdateAssessmentTargetInput)
    pub fn builder() -> crate::input::update_assessment_target_input::Builder {
        crate::input::update_assessment_target_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateAssessmentTarget {
    type Output = std::result::Result<
        crate::output::UpdateAssessmentTargetOutput,
        crate::error::UpdateAssessmentTargetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_assessment_target_error(response)
        } else {
            crate::operation_deser::parse_update_assessment_target_response(response)
        }
    }
}
