#![allow(clippy::module_inception)]
#![allow(clippy::upper_case_acronyms)]
#![allow(clippy::large_enum_variant)]
#![allow(clippy::wrong_self_convention)]
#![allow(clippy::should_implement_trait)]
#![allow(clippy::blacklisted_name)]
//! <fullname>AWS Marketplace Entitlement Service</fullname>
//! <p>This reference provides descriptions of the AWS Marketplace Entitlement Service
//! API.</p>
//! <p>AWS Marketplace Entitlement Service is used to determine the entitlement of a customer to
//! a given product. An entitlement represents capacity in a product owned by the customer. For
//! example, a customer might own some number of users or seats in an SaaS application or some
//! amount of data capacity in a multi-tenant database.</p>
//! <p>
//! <b>Getting Entitlement Records</b>
//! </p>
//! <ul>
//! <li>
//! <p>
//! <i>GetEntitlements</i>- Gets the entitlements for a Marketplace
//! product.</p>
//! </li>
//! </ul>

// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
pub use error_meta::Error;

pub use config::Config;

mod aws_endpoint;
#[cfg(feature = "client")]
pub mod client;
pub mod config;
pub mod error;
mod error_meta;
pub mod input;
mod json_deser;
mod json_errors;
mod json_ser;
pub mod model;
pub mod operation;
mod operation_deser;
mod operation_ser;
pub mod output;
pub static PKG_VERSION: &str = env!("CARGO_PKG_VERSION");
pub use smithy_http::byte_stream::ByteStream;
pub use smithy_http::result::SdkError;
pub use smithy_types::Blob;
static API_METADATA: aws_http::user_agent::ApiMetadata =
    aws_http::user_agent::ApiMetadata::new("marketplaceentitlementservice", PKG_VERSION);
pub use aws_auth::Credentials;
pub use aws_types::region::Region;
#[cfg(feature = "client")]
pub use client::Client;
pub use smithy_http::endpoint::Endpoint;
