// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[non_exhaustive]
#[derive(std::fmt::Debug)]
pub enum Error {
    ExpiredTokenException(crate::error::ExpiredTokenException),
    IdpCommunicationErrorException(crate::error::IdpCommunicationErrorException),
    IdpRejectedClaimException(crate::error::IdpRejectedClaimException),
    InvalidAuthorizationMessageException(crate::error::InvalidAuthorizationMessageException),
    InvalidIdentityTokenException(crate::error::InvalidIdentityTokenException),
    MalformedPolicyDocumentException(crate::error::MalformedPolicyDocumentException),
    PackedPolicyTooLargeException(crate::error::PackedPolicyTooLargeException),
    RegionDisabledException(crate::error::RegionDisabledException),
    Unhandled(Box<dyn std::error::Error + Send + Sync + 'static>),
}
impl std::fmt::Display for Error {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        match self {
            Error::ExpiredTokenException(inner) => inner.fmt(f),
            Error::IdpCommunicationErrorException(inner) => inner.fmt(f),
            Error::IdpRejectedClaimException(inner) => inner.fmt(f),
            Error::InvalidAuthorizationMessageException(inner) => inner.fmt(f),
            Error::InvalidIdentityTokenException(inner) => inner.fmt(f),
            Error::MalformedPolicyDocumentException(inner) => inner.fmt(f),
            Error::PackedPolicyTooLargeException(inner) => inner.fmt(f),
            Error::RegionDisabledException(inner) => inner.fmt(f),
            Error::Unhandled(inner) => inner.fmt(f),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::AssumeRoleError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::AssumeRoleError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::AssumeRoleErrorKind::ExpiredTokenException(inner) => {
                    Error::ExpiredTokenException(inner)
                }
                crate::error::AssumeRoleErrorKind::MalformedPolicyDocumentException(inner) => {
                    Error::MalformedPolicyDocumentException(inner)
                }
                crate::error::AssumeRoleErrorKind::PackedPolicyTooLargeException(inner) => {
                    Error::PackedPolicyTooLargeException(inner)
                }
                crate::error::AssumeRoleErrorKind::RegionDisabledException(inner) => {
                    Error::RegionDisabledException(inner)
                }
                crate::error::AssumeRoleErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::AssumeRoleWithSAMLError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::AssumeRoleWithSAMLError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::AssumeRoleWithSAMLErrorKind::ExpiredTokenException(inner) => {
                    Error::ExpiredTokenException(inner)
                }
                crate::error::AssumeRoleWithSAMLErrorKind::IdpRejectedClaimException(inner) => {
                    Error::IdpRejectedClaimException(inner)
                }
                crate::error::AssumeRoleWithSAMLErrorKind::InvalidIdentityTokenException(inner) => {
                    Error::InvalidIdentityTokenException(inner)
                }
                crate::error::AssumeRoleWithSAMLErrorKind::MalformedPolicyDocumentException(
                    inner,
                ) => Error::MalformedPolicyDocumentException(inner),
                crate::error::AssumeRoleWithSAMLErrorKind::PackedPolicyTooLargeException(inner) => {
                    Error::PackedPolicyTooLargeException(inner)
                }
                crate::error::AssumeRoleWithSAMLErrorKind::RegionDisabledException(inner) => {
                    Error::RegionDisabledException(inner)
                }
                crate::error::AssumeRoleWithSAMLErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::AssumeRoleWithWebIdentityError>> for Error {
    fn from(
        err: smithy_http::result::SdkError<crate::error::AssumeRoleWithWebIdentityError>,
    ) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, ..} => match err.kind {
                crate::error::AssumeRoleWithWebIdentityErrorKind::ExpiredTokenException(inner) => Error::ExpiredTokenException(inner),
                crate::error::AssumeRoleWithWebIdentityErrorKind::IdpCommunicationErrorException(inner) => Error::IdpCommunicationErrorException(inner),
                crate::error::AssumeRoleWithWebIdentityErrorKind::IdpRejectedClaimException(inner) => Error::IdpRejectedClaimException(inner),
                crate::error::AssumeRoleWithWebIdentityErrorKind::InvalidIdentityTokenException(inner) => Error::InvalidIdentityTokenException(inner),
                crate::error::AssumeRoleWithWebIdentityErrorKind::MalformedPolicyDocumentException(inner) => Error::MalformedPolicyDocumentException(inner),
                crate::error::AssumeRoleWithWebIdentityErrorKind::PackedPolicyTooLargeException(inner) => Error::PackedPolicyTooLargeException(inner),
                crate::error::AssumeRoleWithWebIdentityErrorKind::RegionDisabledException(inner) => Error::RegionDisabledException(inner),
                crate::error::AssumeRoleWithWebIdentityErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            }
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::DecodeAuthorizationMessageError>> for Error {
    fn from(
        err: smithy_http::result::SdkError<crate::error::DecodeAuthorizationMessageError>,
    ) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, ..} => match err.kind {
                crate::error::DecodeAuthorizationMessageErrorKind::InvalidAuthorizationMessageException(inner) => Error::InvalidAuthorizationMessageException(inner),
                crate::error::DecodeAuthorizationMessageErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            }
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::GetAccessKeyInfoError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::GetAccessKeyInfoError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::GetAccessKeyInfoErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::GetCallerIdentityError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::GetCallerIdentityError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::GetCallerIdentityErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::GetFederationTokenError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::GetFederationTokenError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::GetFederationTokenErrorKind::MalformedPolicyDocumentException(
                    inner,
                ) => Error::MalformedPolicyDocumentException(inner),
                crate::error::GetFederationTokenErrorKind::PackedPolicyTooLargeException(inner) => {
                    Error::PackedPolicyTooLargeException(inner)
                }
                crate::error::GetFederationTokenErrorKind::RegionDisabledException(inner) => {
                    Error::RegionDisabledException(inner)
                }
                crate::error::GetFederationTokenErrorKind::Unhandled(inner) => {
                    Error::Unhandled(inner)
                }
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl From<smithy_http::result::SdkError<crate::error::GetSessionTokenError>> for Error {
    fn from(err: smithy_http::result::SdkError<crate::error::GetSessionTokenError>) -> Self {
        match err {
            smithy_http::result::SdkError::ServiceError { err, .. } => match err.kind {
                crate::error::GetSessionTokenErrorKind::RegionDisabledException(inner) => {
                    Error::RegionDisabledException(inner)
                }
                crate::error::GetSessionTokenErrorKind::Unhandled(inner) => Error::Unhandled(inner),
            },
            _ => Error::Unhandled(err.into()),
        }
    }
}
impl std::error::Error for Error {}
