// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates a <code>ByteMatchSet</code>. You then use <a>UpdateByteMatchSet</a> to identify the part of a
/// web request that you want AWS WAF to inspect, such as the values of the <code>User-Agent</code> header or the query string.
/// For example, you can create a <code>ByteMatchSet</code> that matches any requests with <code>User-Agent</code> headers
/// that contain the string <code>BadBot</code>. You can then configure AWS WAF to reject those requests.</p>
/// <p>To create and configure a <code>ByteMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>CreateByteMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateByteMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <code>UpdateByteMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit an <a>UpdateByteMatchSet</a> request to specify the part of the request that you want AWS WAF to inspect
/// (for example, the header or the URI) and the value that you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateByteMatchSet {
    _private: (),
}
impl CreateByteMatchSet {
    /// Creates a new builder-style object to manufacture [`CreateByteMatchSetInput`](crate::input::CreateByteMatchSetInput)
    pub fn builder() -> crate::input::create_byte_match_set_input::Builder {
        crate::input::create_byte_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateByteMatchSet {
    type Output = std::result::Result<
        crate::output::CreateByteMatchSetOutput,
        crate::error::CreateByteMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_byte_match_set_error(response)
        } else {
            crate::operation_deser::parse_create_byte_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates an <a>GeoMatchSet</a>, which you use to specify which web requests you want to allow or block based on the country
/// that the requests originate from. For example, if you're receiving a lot of requests from one or more countries and you want to block the requests, you can create an <code>GeoMatchSet</code> that contains those countries and then configure AWS WAF to block the requests. </p>
/// <p>To create and configure a <code>GeoMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>CreateGeoMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateGeoMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateGeoMatchSet</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateGeoMatchSetSet</code> request to specify the countries that you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateGeoMatchSet {
    _private: (),
}
impl CreateGeoMatchSet {
    /// Creates a new builder-style object to manufacture [`CreateGeoMatchSetInput`](crate::input::CreateGeoMatchSetInput)
    pub fn builder() -> crate::input::create_geo_match_set_input::Builder {
        crate::input::create_geo_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateGeoMatchSet {
    type Output = std::result::Result<
        crate::output::CreateGeoMatchSetOutput,
        crate::error::CreateGeoMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_geo_match_set_error(response)
        } else {
            crate::operation_deser::parse_create_geo_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates an <a>IPSet</a>, which you use to specify which web requests
/// that
/// you want to allow or block based on the IP addresses that the requests
/// originate from. For example, if you're receiving a lot of requests from one or more
/// individual IP addresses or one or more ranges of IP addresses and you want to block the
/// requests, you can create an <code>IPSet</code> that contains those IP addresses and then
/// configure AWS WAF to block the requests. </p>
/// <p>To create and configure an <code>IPSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>CreateIPSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateIPSet</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateIPSet</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateIPSet</code> request to specify the IP addresses that you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateIPSet {
    _private: (),
}
impl CreateIPSet {
    /// Creates a new builder-style object to manufacture [`CreateIpSetInput`](crate::input::CreateIpSetInput)
    pub fn builder() -> crate::input::create_ip_set_input::Builder {
        crate::input::create_ip_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateIPSet {
    type Output =
        std::result::Result<crate::output::CreateIpSetOutput, crate::error::CreateIPSetError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_ip_set_error(response)
        } else {
            crate::operation_deser::parse_create_ip_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates a <a>RateBasedRule</a>. The <code>RateBasedRule</code> contains a
/// <code>RateLimit</code>, which specifies the maximum number of requests that AWS WAF allows
/// from a specified IP address in a five-minute period.  
/// The <code>RateBasedRule</code> also
/// contains the <code>IPSet</code> objects, <code>ByteMatchSet</code> objects, and other
/// predicates that identify the requests that you want to count or block if these requests
/// exceed the <code>RateLimit</code>.</p>
/// <p>If you add more than one predicate to a <code>RateBasedRule</code>, a request not
/// only must exceed the <code>RateLimit</code>, but it also must match all the
/// conditions to be counted or blocked. For example, suppose you add the following to a
/// <code>RateBasedRule</code>:</p>
/// <ul>
/// <li>
/// <p>An <code>IPSet</code> that matches the IP address <code>192.0.2.44/32</code>
/// </p>
/// </li>
/// <li>
/// <p>A <code>ByteMatchSet</code> that matches <code>BadBot</code> in the
/// <code>User-Agent</code> header</p>
/// </li>
/// </ul>
/// <p>Further, you specify a <code>RateLimit</code> of 1,000.</p>
/// <p>You then add the <code>RateBasedRule</code> to a <code>WebACL</code> and specify that
/// you want to block requests that meet the conditions in the rule. For a request to be
/// blocked, it must come from the IP address 192.0.2.44 <i>and</i> the
/// <code>User-Agent</code> header in the request must contain the value
/// <code>BadBot</code>. Further, requests that match these two conditions must be received at
/// a rate of more than 1,000 requests every five minutes. If both conditions are met and the
/// rate is exceeded, AWS WAF blocks the requests. If the rate drops below 1,000 for a
/// five-minute period, AWS WAF no longer blocks the requests.</p>
/// <p>As a second example, suppose you want to limit requests to a particular page on your site. To do this, you could add the following to a
/// <code>RateBasedRule</code>:</p>
/// <ul>
/// <li>
/// <p>A <code>ByteMatchSet</code> with <code>FieldToMatch</code> of <code>URI</code>
/// </p>
/// </li>
/// <li>
/// <p>A <code>PositionalConstraint</code> of <code>STARTS_WITH</code>
/// </p>
/// </li>
/// <li>
/// <p>A <code>TargetString</code> of <code>login</code>
/// </p>
/// </li>
/// </ul>
/// <p>Further, you specify a <code>RateLimit</code> of 1,000.</p>
/// <p>By adding this <code>RateBasedRule</code> to a <code>WebACL</code>, you could limit requests to your login page without affecting the rest of your site.</p>
/// <p>To create and configure a <code>RateBasedRule</code>, perform the following
/// steps:</p>
/// <ol>
/// <li>
/// <p>Create and update the predicates that you want to include in the rule. For more
/// information, see <a>CreateByteMatchSet</a>, <a>CreateIPSet</a>,
/// and <a>CreateSqlInjectionMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide
/// in the <code>ChangeToken</code> parameter of a <code>CreateRule</code>
/// request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateRateBasedRule</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the
/// <code>ChangeToken</code> parameter of an <a>UpdateRule</a>
/// request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateRateBasedRule</code> request to specify the predicates
/// that you want to include in the rule.</p>
/// </li>
/// <li>
/// <p>Create and update a <code>WebACL</code> that contains the
/// <code>RateBasedRule</code>. For more information, see <a>CreateWebACL</a>.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests,
/// see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer
/// Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateRateBasedRule {
    _private: (),
}
impl CreateRateBasedRule {
    /// Creates a new builder-style object to manufacture [`CreateRateBasedRuleInput`](crate::input::CreateRateBasedRuleInput)
    pub fn builder() -> crate::input::create_rate_based_rule_input::Builder {
        crate::input::create_rate_based_rule_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateRateBasedRule {
    type Output = std::result::Result<
        crate::output::CreateRateBasedRuleOutput,
        crate::error::CreateRateBasedRuleError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_rate_based_rule_error(response)
        } else {
            crate::operation_deser::parse_create_rate_based_rule_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates a <a>RegexMatchSet</a>. You then use <a>UpdateRegexMatchSet</a> to identify the part of a
/// web request that you want AWS WAF to inspect, such as the values of the <code>User-Agent</code> header or the query string.
/// For example, you can create a <code>RegexMatchSet</code> that contains a <code>RegexMatchTuple</code> that looks for any requests with <code>User-Agent</code> headers
/// that match a <code>RegexPatternSet</code> with pattern <code>B[a@]dB[o0]t</code>. You can then configure AWS WAF to reject those requests.</p>
/// <p>To create and configure a <code>RegexMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>CreateRegexMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateRegexMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <code>UpdateRegexMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit an <a>UpdateRegexMatchSet</a> request to specify the part of the request that you want AWS WAF to inspect
/// (for example, the header or the URI) and the value, using a <code>RegexPatternSet</code>, that you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateRegexMatchSet {
    _private: (),
}
impl CreateRegexMatchSet {
    /// Creates a new builder-style object to manufacture [`CreateRegexMatchSetInput`](crate::input::CreateRegexMatchSetInput)
    pub fn builder() -> crate::input::create_regex_match_set_input::Builder {
        crate::input::create_regex_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateRegexMatchSet {
    type Output = std::result::Result<
        crate::output::CreateRegexMatchSetOutput,
        crate::error::CreateRegexMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_regex_match_set_error(response)
        } else {
            crate::operation_deser::parse_create_regex_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates a <code>RegexPatternSet</code>. You then use <a>UpdateRegexPatternSet</a> to specify the regular expression (regex) pattern that you want AWS WAF to search for, such as <code>B[a@]dB[o0]t</code>. You can then configure AWS WAF to reject those requests.</p>
/// <p>To create and configure a <code>RegexPatternSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>CreateRegexPatternSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateRegexPatternSet</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <code>UpdateRegexPatternSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit an <a>UpdateRegexPatternSet</a> request to specify the string that you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateRegexPatternSet {
    _private: (),
}
impl CreateRegexPatternSet {
    /// Creates a new builder-style object to manufacture [`CreateRegexPatternSetInput`](crate::input::CreateRegexPatternSetInput)
    pub fn builder() -> crate::input::create_regex_pattern_set_input::Builder {
        crate::input::create_regex_pattern_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateRegexPatternSet {
    type Output = std::result::Result<
        crate::output::CreateRegexPatternSetOutput,
        crate::error::CreateRegexPatternSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_regex_pattern_set_error(response)
        } else {
            crate::operation_deser::parse_create_regex_pattern_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates a <code>Rule</code>, which contains the <code>IPSet</code> objects,
/// <code>ByteMatchSet</code> objects, and other predicates that identify the requests that
/// you want to block. If you add more than one predicate to a <code>Rule</code>, a request
/// must match all of the specifications to be allowed or blocked. For example, suppose
/// that
/// you add the following to a <code>Rule</code>:</p>
/// <ul>
/// <li>
/// <p>An <code>IPSet</code> that matches the IP address <code>192.0.2.44/32</code>
/// </p>
/// </li>
/// <li>
/// <p>A <code>ByteMatchSet</code> that matches <code>BadBot</code> in the <code>User-Agent</code> header</p>
/// </li>
/// </ul>
/// <p>You then add the <code>Rule</code> to a <code>WebACL</code> and specify that you want to blocks requests that satisfy the <code>Rule</code>.
/// For a request to be blocked, it must come from the IP address 192.0.2.44 <i>and</i> the <code>User-Agent</code> header in the request
/// must contain the value <code>BadBot</code>.</p>
/// <p>To create and configure a <code>Rule</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Create and update the predicates that you want to include in the <code>Rule</code>. For more information, see
/// <a>CreateByteMatchSet</a>, <a>CreateIPSet</a>, and <a>CreateSqlInjectionMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>CreateRule</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateRule</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateRule</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateRule</code> request to specify the predicates that you want to include in the <code>Rule</code>.</p>
/// </li>
/// <li>
/// <p>Create and update a <code>WebACL</code> that contains the <code>Rule</code>. For more information, see <a>CreateWebACL</a>.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateRule {
    _private: (),
}
impl CreateRule {
    /// Creates a new builder-style object to manufacture [`CreateRuleInput`](crate::input::CreateRuleInput)
    pub fn builder() -> crate::input::create_rule_input::Builder {
        crate::input::create_rule_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateRule {
    type Output =
        std::result::Result<crate::output::CreateRuleOutput, crate::error::CreateRuleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_rule_error(response)
        } else {
            crate::operation_deser::parse_create_rule_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates a <code>RuleGroup</code>. A rule group is a collection of predefined rules that you add to a web ACL. You use <a>UpdateRuleGroup</a> to add rules to the rule group.</p>
/// <p>Rule groups are subject to the following limits:</p>
/// <ul>
/// <li>
/// <p>Three rule groups per account. You can request an increase to this limit by contacting customer support.</p>
/// </li>
/// <li>
/// <p>One rule group per web ACL.</p>
/// </li>
/// <li>
/// <p>Ten rules per rule group.</p>
/// </li>
/// </ul>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateRuleGroup {
    _private: (),
}
impl CreateRuleGroup {
    /// Creates a new builder-style object to manufacture [`CreateRuleGroupInput`](crate::input::CreateRuleGroupInput)
    pub fn builder() -> crate::input::create_rule_group_input::Builder {
        crate::input::create_rule_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateRuleGroup {
    type Output = std::result::Result<
        crate::output::CreateRuleGroupOutput,
        crate::error::CreateRuleGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_rule_group_error(response)
        } else {
            crate::operation_deser::parse_create_rule_group_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates a <code>SizeConstraintSet</code>. You then use <a>UpdateSizeConstraintSet</a> to identify the part of a
/// web request that you want AWS WAF to check for length, such as the length of the <code>User-Agent</code> header or the length of the query string.
/// For example, you can create a <code>SizeConstraintSet</code> that matches any requests that have a query string that is longer than 100 bytes.
/// You can then configure AWS WAF to reject those requests.</p>
/// <p>To create and configure a <code>SizeConstraintSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>CreateSizeConstraintSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateSizeConstraintSet</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <code>UpdateSizeConstraintSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit an <a>UpdateSizeConstraintSet</a> request to specify the part of the request that you want AWS WAF to inspect
/// (for example, the header or the URI) and the value that you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateSizeConstraintSet {
    _private: (),
}
impl CreateSizeConstraintSet {
    /// Creates a new builder-style object to manufacture [`CreateSizeConstraintSetInput`](crate::input::CreateSizeConstraintSetInput)
    pub fn builder() -> crate::input::create_size_constraint_set_input::Builder {
        crate::input::create_size_constraint_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateSizeConstraintSet {
    type Output = std::result::Result<
        crate::output::CreateSizeConstraintSetOutput,
        crate::error::CreateSizeConstraintSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_size_constraint_set_error(response)
        } else {
            crate::operation_deser::parse_create_size_constraint_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates a <a>SqlInjectionMatchSet</a>, which you use to allow, block, or count requests that contain snippets of SQL code in a
/// specified part of web requests. AWS WAF searches for character sequences that are likely to be malicious strings.</p>
/// <p>To create and configure a <code>SqlInjectionMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>CreateSqlInjectionMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateSqlInjectionMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateSqlInjectionMatchSet</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <a>UpdateSqlInjectionMatchSet</a> request to specify the parts of web requests in which you want to
/// allow, block, or count malicious SQL code.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateSqlInjectionMatchSet {
    _private: (),
}
impl CreateSqlInjectionMatchSet {
    /// Creates a new builder-style object to manufacture [`CreateSqlInjectionMatchSetInput`](crate::input::CreateSqlInjectionMatchSetInput)
    pub fn builder() -> crate::input::create_sql_injection_match_set_input::Builder {
        crate::input::create_sql_injection_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateSqlInjectionMatchSet {
    type Output = std::result::Result<
        crate::output::CreateSqlInjectionMatchSetOutput,
        crate::error::CreateSqlInjectionMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_sql_injection_match_set_error(response)
        } else {
            crate::operation_deser::parse_create_sql_injection_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates a <code>WebACL</code>, which contains the <code>Rules</code> that identify the CloudFront web requests that you want to allow, block, or count.
/// AWS WAF evaluates <code>Rules</code> in order based on the value of <code>Priority</code> for each <code>Rule</code>.</p>      
/// <p>You also specify a default action, either <code>ALLOW</code> or <code>BLOCK</code>. If a web request doesn't match
/// any of the <code>Rules</code> in a <code>WebACL</code>, AWS WAF responds to the request with the default action. </p>      
/// <p>To create and configure a <code>WebACL</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Create and update the <code>ByteMatchSet</code> objects and other predicates that you want to include in <code>Rules</code>.
/// For more information, see <a>CreateByteMatchSet</a>, <a>UpdateByteMatchSet</a>, <a>CreateIPSet</a>, <a>UpdateIPSet</a>,
/// <a>CreateSqlInjectionMatchSet</a>, and <a>UpdateSqlInjectionMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Create and update the <code>Rules</code> that you want to include in the <code>WebACL</code>. For more information, see
/// <a>CreateRule</a> and <a>UpdateRule</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>CreateWebACL</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateWebACL</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateWebACL</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <a>UpdateWebACL</a> request to specify the <code>Rules</code> that you want to include in the <code>WebACL</code>,
/// to specify the default action, and to associate the <code>WebACL</code> with a CloudFront distribution.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API, see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateWebACL {
    _private: (),
}
impl CreateWebACL {
    /// Creates a new builder-style object to manufacture [`CreateWebAclInput`](crate::input::CreateWebAclInput)
    pub fn builder() -> crate::input::create_web_acl_input::Builder {
        crate::input::create_web_acl_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateWebACL {
    type Output =
        std::result::Result<crate::output::CreateWebAclOutput, crate::error::CreateWebACLError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_web_acl_error(response)
        } else {
            crate::operation_deser::parse_create_web_acl_response(response)
        }
    }
}

/// <p>Creates an AWS CloudFormation WAFV2 template for the specified web ACL in the specified Amazon S3 bucket.
/// Then, in CloudFormation, you create a stack from the template, to create the web ACL and its resources in AWS WAFV2.
/// Use this to migrate your AWS WAF Classic web ACL to the latest version of AWS WAF.</p>
/// <p>This is part of a larger migration procedure for web ACLs from AWS WAF Classic to the latest version of AWS WAF.
/// For the full procedure, including caveats and manual steps to complete
/// the migration and switch over to the new web ACL, see  
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-migrating-from-classic.html">Migrating your AWS WAF Classic resources to AWS WAF</a> in the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF     
/// Developer Guide</a>.  </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateWebACLMigrationStack {
    _private: (),
}
impl CreateWebACLMigrationStack {
    /// Creates a new builder-style object to manufacture [`CreateWebAclMigrationStackInput`](crate::input::CreateWebAclMigrationStackInput)
    pub fn builder() -> crate::input::create_web_acl_migration_stack_input::Builder {
        crate::input::create_web_acl_migration_stack_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateWebACLMigrationStack {
    type Output = std::result::Result<
        crate::output::CreateWebAclMigrationStackOutput,
        crate::error::CreateWebACLMigrationStackError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_web_acl_migration_stack_error(response)
        } else {
            crate::operation_deser::parse_create_web_acl_migration_stack_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Creates an <a>XssMatchSet</a>, which you use to allow, block, or count requests that contain cross-site scripting attacks
/// in the specified part of web requests. AWS WAF searches for character sequences that are likely to be malicious strings.</p>
/// <p>To create and configure an <code>XssMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>CreateXssMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>CreateXssMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateXssMatchSet</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <a>UpdateXssMatchSet</a> request to specify the parts of web requests in which you want to
/// allow, block, or count cross-site scripting attacks.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct CreateXssMatchSet {
    _private: (),
}
impl CreateXssMatchSet {
    /// Creates a new builder-style object to manufacture [`CreateXssMatchSetInput`](crate::input::CreateXssMatchSetInput)
    pub fn builder() -> crate::input::create_xss_match_set_input::Builder {
        crate::input::create_xss_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for CreateXssMatchSet {
    type Output = std::result::Result<
        crate::output::CreateXssMatchSetOutput,
        crate::error::CreateXssMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_create_xss_match_set_error(response)
        } else {
            crate::operation_deser::parse_create_xss_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes a <a>ByteMatchSet</a>. You can't delete a <code>ByteMatchSet</code> if it's still used in any <code>Rules</code>
/// or if it still includes any <a>ByteMatchTuple</a> objects (any filters).</p>    
/// <p>If you just want to remove a <code>ByteMatchSet</code> from a <code>Rule</code>, use <a>UpdateRule</a>.</p>    
/// <p>To permanently delete a <code>ByteMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>ByteMatchSet</code> to remove filters, if any. For more information, see <a>UpdateByteMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>DeleteByteMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteByteMatchSet</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteByteMatchSet {
    _private: (),
}
impl DeleteByteMatchSet {
    /// Creates a new builder-style object to manufacture [`DeleteByteMatchSetInput`](crate::input::DeleteByteMatchSetInput)
    pub fn builder() -> crate::input::delete_byte_match_set_input::Builder {
        crate::input::delete_byte_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteByteMatchSet {
    type Output = std::result::Result<
        crate::output::DeleteByteMatchSetOutput,
        crate::error::DeleteByteMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_byte_match_set_error(response)
        } else {
            crate::operation_deser::parse_delete_byte_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes a <a>GeoMatchSet</a>. You can't delete a <code>GeoMatchSet</code> if it's still used in any <code>Rules</code> or
/// if it still includes any countries.</p>
/// <p>If you just want to remove a <code>GeoMatchSet</code> from a <code>Rule</code>, use <a>UpdateRule</a>.</p>
/// <p>To permanently delete a <code>GeoMatchSet</code> from AWS WAF, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>GeoMatchSet</code> to remove any countries. For more information, see <a>UpdateGeoMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>DeleteGeoMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteGeoMatchSet</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteGeoMatchSet {
    _private: (),
}
impl DeleteGeoMatchSet {
    /// Creates a new builder-style object to manufacture [`DeleteGeoMatchSetInput`](crate::input::DeleteGeoMatchSetInput)
    pub fn builder() -> crate::input::delete_geo_match_set_input::Builder {
        crate::input::delete_geo_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteGeoMatchSet {
    type Output = std::result::Result<
        crate::output::DeleteGeoMatchSetOutput,
        crate::error::DeleteGeoMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_geo_match_set_error(response)
        } else {
            crate::operation_deser::parse_delete_geo_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes an <a>IPSet</a>. You can't delete an <code>IPSet</code> if it's still used in any <code>Rules</code> or
/// if it still includes any IP addresses.</p>
/// <p>If you just want to remove an <code>IPSet</code> from a <code>Rule</code>, use <a>UpdateRule</a>.</p>
/// <p>To permanently delete an <code>IPSet</code> from AWS WAF, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>IPSet</code> to remove IP address ranges, if any. For more information, see <a>UpdateIPSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>DeleteIPSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteIPSet</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteIPSet {
    _private: (),
}
impl DeleteIPSet {
    /// Creates a new builder-style object to manufacture [`DeleteIpSetInput`](crate::input::DeleteIpSetInput)
    pub fn builder() -> crate::input::delete_ip_set_input::Builder {
        crate::input::delete_ip_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteIPSet {
    type Output =
        std::result::Result<crate::output::DeleteIpSetOutput, crate::error::DeleteIPSetError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_ip_set_error(response)
        } else {
            crate::operation_deser::parse_delete_ip_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes the <a>LoggingConfiguration</a> from the specified web
/// ACL.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteLoggingConfiguration {
    _private: (),
}
impl DeleteLoggingConfiguration {
    /// Creates a new builder-style object to manufacture [`DeleteLoggingConfigurationInput`](crate::input::DeleteLoggingConfigurationInput)
    pub fn builder() -> crate::input::delete_logging_configuration_input::Builder {
        crate::input::delete_logging_configuration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteLoggingConfiguration {
    type Output = std::result::Result<
        crate::output::DeleteLoggingConfigurationOutput,
        crate::error::DeleteLoggingConfigurationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_logging_configuration_error(response)
        } else {
            crate::operation_deser::parse_delete_logging_configuration_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes an IAM policy from the specified RuleGroup.</p>
/// <p>The user making the request must be the owner of the RuleGroup.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeletePermissionPolicy {
    _private: (),
}
impl DeletePermissionPolicy {
    /// Creates a new builder-style object to manufacture [`DeletePermissionPolicyInput`](crate::input::DeletePermissionPolicyInput)
    pub fn builder() -> crate::input::delete_permission_policy_input::Builder {
        crate::input::delete_permission_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeletePermissionPolicy {
    type Output = std::result::Result<
        crate::output::DeletePermissionPolicyOutput,
        crate::error::DeletePermissionPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_permission_policy_error(response)
        } else {
            crate::operation_deser::parse_delete_permission_policy_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes a <a>RateBasedRule</a>. You can't delete a rule if
/// it's still used in any <code>WebACL</code> objects or if it still includes any predicates,
/// such as <code>ByteMatchSet</code> objects.</p>
/// <p>If you just want to remove a rule from a <code>WebACL</code>, use <a>UpdateWebACL</a>.</p>
/// <p>To permanently delete a <code>RateBasedRule</code> from AWS WAF, perform the following
/// steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>RateBasedRule</code> to remove predicates, if any. For more
/// information, see <a>UpdateRateBasedRule</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide
/// in the <code>ChangeToken</code> parameter of a <code>DeleteRateBasedRule</code>
/// request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteRateBasedRule</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteRateBasedRule {
    _private: (),
}
impl DeleteRateBasedRule {
    /// Creates a new builder-style object to manufacture [`DeleteRateBasedRuleInput`](crate::input::DeleteRateBasedRuleInput)
    pub fn builder() -> crate::input::delete_rate_based_rule_input::Builder {
        crate::input::delete_rate_based_rule_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteRateBasedRule {
    type Output = std::result::Result<
        crate::output::DeleteRateBasedRuleOutput,
        crate::error::DeleteRateBasedRuleError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_rate_based_rule_error(response)
        } else {
            crate::operation_deser::parse_delete_rate_based_rule_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes a <a>RegexMatchSet</a>. You can't delete a <code>RegexMatchSet</code> if it's still used in any <code>Rules</code>
/// or if it still includes any <code>RegexMatchTuples</code> objects (any filters).</p>    
/// <p>If you just want to remove a <code>RegexMatchSet</code> from a <code>Rule</code>, use <a>UpdateRule</a>.</p>    
/// <p>To permanently delete a <code>RegexMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>RegexMatchSet</code> to remove filters, if any. For more information, see <a>UpdateRegexMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>DeleteRegexMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteRegexMatchSet</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteRegexMatchSet {
    _private: (),
}
impl DeleteRegexMatchSet {
    /// Creates a new builder-style object to manufacture [`DeleteRegexMatchSetInput`](crate::input::DeleteRegexMatchSetInput)
    pub fn builder() -> crate::input::delete_regex_match_set_input::Builder {
        crate::input::delete_regex_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteRegexMatchSet {
    type Output = std::result::Result<
        crate::output::DeleteRegexMatchSetOutput,
        crate::error::DeleteRegexMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_regex_match_set_error(response)
        } else {
            crate::operation_deser::parse_delete_regex_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes a <a>RegexPatternSet</a>. You can't delete a <code>RegexPatternSet</code> if it's still used in any <code>RegexMatchSet</code>
/// or if the <code>RegexPatternSet</code> is not empty. </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteRegexPatternSet {
    _private: (),
}
impl DeleteRegexPatternSet {
    /// Creates a new builder-style object to manufacture [`DeleteRegexPatternSetInput`](crate::input::DeleteRegexPatternSetInput)
    pub fn builder() -> crate::input::delete_regex_pattern_set_input::Builder {
        crate::input::delete_regex_pattern_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteRegexPatternSet {
    type Output = std::result::Result<
        crate::output::DeleteRegexPatternSetOutput,
        crate::error::DeleteRegexPatternSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_regex_pattern_set_error(response)
        } else {
            crate::operation_deser::parse_delete_regex_pattern_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes a <a>Rule</a>. You can't delete a <code>Rule</code> if it's still used in any <code>WebACL</code>
/// objects or if it still includes any predicates, such as <code>ByteMatchSet</code> objects.</p>
/// <p>If you just want to remove a <code>Rule</code> from a <code>WebACL</code>, use <a>UpdateWebACL</a>.</p>
/// <p>To permanently delete a <code>Rule</code> from AWS WAF, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>Rule</code> to remove predicates, if any. For more information, see <a>UpdateRule</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>DeleteRule</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteRule</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteRule {
    _private: (),
}
impl DeleteRule {
    /// Creates a new builder-style object to manufacture [`DeleteRuleInput`](crate::input::DeleteRuleInput)
    pub fn builder() -> crate::input::delete_rule_input::Builder {
        crate::input::delete_rule_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteRule {
    type Output =
        std::result::Result<crate::output::DeleteRuleOutput, crate::error::DeleteRuleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_rule_error(response)
        } else {
            crate::operation_deser::parse_delete_rule_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes a <a>RuleGroup</a>. You can't delete a <code>RuleGroup</code> if it's still used in any <code>WebACL</code>
/// objects or if it still includes any rules.</p>
/// <p>If you just want to remove a <code>RuleGroup</code> from a <code>WebACL</code>, use <a>UpdateWebACL</a>.</p>
/// <p>To permanently delete a <code>RuleGroup</code> from AWS WAF, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>RuleGroup</code> to remove rules, if any. For more information, see <a>UpdateRuleGroup</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>DeleteRuleGroup</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteRuleGroup</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteRuleGroup {
    _private: (),
}
impl DeleteRuleGroup {
    /// Creates a new builder-style object to manufacture [`DeleteRuleGroupInput`](crate::input::DeleteRuleGroupInput)
    pub fn builder() -> crate::input::delete_rule_group_input::Builder {
        crate::input::delete_rule_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteRuleGroup {
    type Output = std::result::Result<
        crate::output::DeleteRuleGroupOutput,
        crate::error::DeleteRuleGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_rule_group_error(response)
        } else {
            crate::operation_deser::parse_delete_rule_group_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes a <a>SizeConstraintSet</a>. You can't delete a <code>SizeConstraintSet</code> if it's still used in any <code>Rules</code>
/// or if it still includes any <a>SizeConstraint</a> objects (any filters).</p>    
/// <p>If you just want to remove a <code>SizeConstraintSet</code> from a <code>Rule</code>, use <a>UpdateRule</a>.</p>    
/// <p>To permanently delete a <code>SizeConstraintSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>SizeConstraintSet</code> to remove filters, if any. For more information, see <a>UpdateSizeConstraintSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>DeleteSizeConstraintSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteSizeConstraintSet</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteSizeConstraintSet {
    _private: (),
}
impl DeleteSizeConstraintSet {
    /// Creates a new builder-style object to manufacture [`DeleteSizeConstraintSetInput`](crate::input::DeleteSizeConstraintSetInput)
    pub fn builder() -> crate::input::delete_size_constraint_set_input::Builder {
        crate::input::delete_size_constraint_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteSizeConstraintSet {
    type Output = std::result::Result<
        crate::output::DeleteSizeConstraintSetOutput,
        crate::error::DeleteSizeConstraintSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_size_constraint_set_error(response)
        } else {
            crate::operation_deser::parse_delete_size_constraint_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes a <a>SqlInjectionMatchSet</a>. You can't delete a <code>SqlInjectionMatchSet</code> if it's
/// still used in any <code>Rules</code> or if it still contains any <a>SqlInjectionMatchTuple</a> objects.</p>
/// <p>If you just want to remove a <code>SqlInjectionMatchSet</code> from a <code>Rule</code>, use <a>UpdateRule</a>.</p>
/// <p>To permanently delete a <code>SqlInjectionMatchSet</code> from AWS WAF, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>SqlInjectionMatchSet</code> to remove filters, if any. For more information, see
/// <a>UpdateSqlInjectionMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>DeleteSqlInjectionMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteSqlInjectionMatchSet</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteSqlInjectionMatchSet {
    _private: (),
}
impl DeleteSqlInjectionMatchSet {
    /// Creates a new builder-style object to manufacture [`DeleteSqlInjectionMatchSetInput`](crate::input::DeleteSqlInjectionMatchSetInput)
    pub fn builder() -> crate::input::delete_sql_injection_match_set_input::Builder {
        crate::input::delete_sql_injection_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteSqlInjectionMatchSet {
    type Output = std::result::Result<
        crate::output::DeleteSqlInjectionMatchSetOutput,
        crate::error::DeleteSqlInjectionMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_sql_injection_match_set_error(response)
        } else {
            crate::operation_deser::parse_delete_sql_injection_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes a <a>WebACL</a>. You can't delete a <code>WebACL</code> if it still contains any <code>Rules</code>.</p>
/// <p>To delete a <code>WebACL</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>WebACL</code> to remove <code>Rules</code>, if any. For more information, see <a>UpdateWebACL</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>DeleteWebACL</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteWebACL</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteWebACL {
    _private: (),
}
impl DeleteWebACL {
    /// Creates a new builder-style object to manufacture [`DeleteWebAclInput`](crate::input::DeleteWebAclInput)
    pub fn builder() -> crate::input::delete_web_acl_input::Builder {
        crate::input::delete_web_acl_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteWebACL {
    type Output =
        std::result::Result<crate::output::DeleteWebAclOutput, crate::error::DeleteWebACLError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_web_acl_error(response)
        } else {
            crate::operation_deser::parse_delete_web_acl_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Permanently deletes an <a>XssMatchSet</a>. You can't delete an <code>XssMatchSet</code> if it's
/// still used in any <code>Rules</code> or if it still contains any <a>XssMatchTuple</a> objects.</p>
/// <p>If you just want to remove an <code>XssMatchSet</code> from a <code>Rule</code>, use <a>UpdateRule</a>.</p>
/// <p>To permanently delete an <code>XssMatchSet</code> from AWS WAF, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Update the <code>XssMatchSet</code> to remove filters, if any. For more information, see
/// <a>UpdateXssMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of a
/// <code>DeleteXssMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit a <code>DeleteXssMatchSet</code> request.</p>
/// </li>
/// </ol>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct DeleteXssMatchSet {
    _private: (),
}
impl DeleteXssMatchSet {
    /// Creates a new builder-style object to manufacture [`DeleteXssMatchSetInput`](crate::input::DeleteXssMatchSetInput)
    pub fn builder() -> crate::input::delete_xss_match_set_input::Builder {
        crate::input::delete_xss_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for DeleteXssMatchSet {
    type Output = std::result::Result<
        crate::output::DeleteXssMatchSetOutput,
        crate::error::DeleteXssMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_delete_xss_match_set_error(response)
        } else {
            crate::operation_deser::parse_delete_xss_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>ByteMatchSet</a> specified by <code>ByteMatchSetId</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetByteMatchSet {
    _private: (),
}
impl GetByteMatchSet {
    /// Creates a new builder-style object to manufacture [`GetByteMatchSetInput`](crate::input::GetByteMatchSetInput)
    pub fn builder() -> crate::input::get_byte_match_set_input::Builder {
        crate::input::get_byte_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetByteMatchSet {
    type Output = std::result::Result<
        crate::output::GetByteMatchSetOutput,
        crate::error::GetByteMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_byte_match_set_error(response)
        } else {
            crate::operation_deser::parse_get_byte_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>When you want to create, update, or delete AWS WAF objects, get a change token and include the change token in the create, update, or delete request. Change tokens ensure that your application doesn't submit conflicting requests to AWS WAF.</p>
/// <p>Each create, update, or delete request must use a unique change token. If your application submits a <code>GetChangeToken</code> request
/// and then submits a second <code>GetChangeToken</code> request before submitting a create, update, or delete request, the second
/// <code>GetChangeToken</code> request returns the same value as the first <code>GetChangeToken</code> request.</p>
/// <p>When you use a change token in a create, update, or delete request, the status of the change token changes to <code>PENDING</code>,
/// which indicates that AWS WAF is propagating the change to all AWS WAF servers. Use <code>GetChangeTokenStatus</code> to determine the
/// status of your change token.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetChangeToken {
    _private: (),
}
impl GetChangeToken {
    /// Creates a new builder-style object to manufacture [`GetChangeTokenInput`](crate::input::GetChangeTokenInput)
    pub fn builder() -> crate::input::get_change_token_input::Builder {
        crate::input::get_change_token_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetChangeToken {
    type Output =
        std::result::Result<crate::output::GetChangeTokenOutput, crate::error::GetChangeTokenError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_change_token_error(response)
        } else {
            crate::operation_deser::parse_get_change_token_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the status of a <code>ChangeToken</code> that you got by calling <a>GetChangeToken</a>. <code>ChangeTokenStatus</code> is
/// one of the following values:</p>
/// <ul>
/// <li>
/// <p>
/// <code>PROVISIONED</code>: You requested the change token by calling <code>GetChangeToken</code>, but you haven't used it yet
/// in a call to create, update, or delete an AWS WAF object.</p>
/// </li>
/// <li>
/// <p>
/// <code>PENDING</code>: AWS WAF is propagating the create, update, or delete request to all AWS WAF servers.</p>
/// </li>
/// <li>
/// <p>
/// <code>INSYNC</code>: Propagation is complete.</p>
/// </li>
/// </ul>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetChangeTokenStatus {
    _private: (),
}
impl GetChangeTokenStatus {
    /// Creates a new builder-style object to manufacture [`GetChangeTokenStatusInput`](crate::input::GetChangeTokenStatusInput)
    pub fn builder() -> crate::input::get_change_token_status_input::Builder {
        crate::input::get_change_token_status_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetChangeTokenStatus {
    type Output = std::result::Result<
        crate::output::GetChangeTokenStatusOutput,
        crate::error::GetChangeTokenStatusError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_change_token_status_error(response)
        } else {
            crate::operation_deser::parse_get_change_token_status_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>GeoMatchSet</a> that is specified by <code>GeoMatchSetId</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetGeoMatchSet {
    _private: (),
}
impl GetGeoMatchSet {
    /// Creates a new builder-style object to manufacture [`GetGeoMatchSetInput`](crate::input::GetGeoMatchSetInput)
    pub fn builder() -> crate::input::get_geo_match_set_input::Builder {
        crate::input::get_geo_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetGeoMatchSet {
    type Output =
        std::result::Result<crate::output::GetGeoMatchSetOutput, crate::error::GetGeoMatchSetError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_geo_match_set_error(response)
        } else {
            crate::operation_deser::parse_get_geo_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>IPSet</a> that is specified by <code>IPSetId</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetIPSet {
    _private: (),
}
impl GetIPSet {
    /// Creates a new builder-style object to manufacture [`GetIpSetInput`](crate::input::GetIpSetInput)
    pub fn builder() -> crate::input::get_ip_set_input::Builder {
        crate::input::get_ip_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetIPSet {
    type Output = std::result::Result<crate::output::GetIpSetOutput, crate::error::GetIPSetError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_ip_set_error(response)
        } else {
            crate::operation_deser::parse_get_ip_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>LoggingConfiguration</a> for the specified web ACL.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetLoggingConfiguration {
    _private: (),
}
impl GetLoggingConfiguration {
    /// Creates a new builder-style object to manufacture [`GetLoggingConfigurationInput`](crate::input::GetLoggingConfigurationInput)
    pub fn builder() -> crate::input::get_logging_configuration_input::Builder {
        crate::input::get_logging_configuration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetLoggingConfiguration {
    type Output = std::result::Result<
        crate::output::GetLoggingConfigurationOutput,
        crate::error::GetLoggingConfigurationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_logging_configuration_error(response)
        } else {
            crate::operation_deser::parse_get_logging_configuration_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the IAM policy attached to the RuleGroup.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetPermissionPolicy {
    _private: (),
}
impl GetPermissionPolicy {
    /// Creates a new builder-style object to manufacture [`GetPermissionPolicyInput`](crate::input::GetPermissionPolicyInput)
    pub fn builder() -> crate::input::get_permission_policy_input::Builder {
        crate::input::get_permission_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetPermissionPolicy {
    type Output = std::result::Result<
        crate::output::GetPermissionPolicyOutput,
        crate::error::GetPermissionPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_permission_policy_error(response)
        } else {
            crate::operation_deser::parse_get_permission_policy_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>RateBasedRule</a> that is specified by the
/// <code>RuleId</code> that you included in the <code>GetRateBasedRule</code>
/// request.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetRateBasedRule {
    _private: (),
}
impl GetRateBasedRule {
    /// Creates a new builder-style object to manufacture [`GetRateBasedRuleInput`](crate::input::GetRateBasedRuleInput)
    pub fn builder() -> crate::input::get_rate_based_rule_input::Builder {
        crate::input::get_rate_based_rule_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetRateBasedRule {
    type Output = std::result::Result<
        crate::output::GetRateBasedRuleOutput,
        crate::error::GetRateBasedRuleError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_rate_based_rule_error(response)
        } else {
            crate::operation_deser::parse_get_rate_based_rule_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of IP addresses currently being blocked by the <a>RateBasedRule</a> that is specified by the <code>RuleId</code>. The maximum
/// number of managed keys that will be blocked is 10,000. If more than 10,000 addresses exceed
/// the rate limit, the 10,000 addresses with the highest rates will be blocked.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetRateBasedRuleManagedKeys {
    _private: (),
}
impl GetRateBasedRuleManagedKeys {
    /// Creates a new builder-style object to manufacture [`GetRateBasedRuleManagedKeysInput`](crate::input::GetRateBasedRuleManagedKeysInput)
    pub fn builder() -> crate::input::get_rate_based_rule_managed_keys_input::Builder {
        crate::input::get_rate_based_rule_managed_keys_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetRateBasedRuleManagedKeys {
    type Output = std::result::Result<
        crate::output::GetRateBasedRuleManagedKeysOutput,
        crate::error::GetRateBasedRuleManagedKeysError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_rate_based_rule_managed_keys_error(response)
        } else {
            crate::operation_deser::parse_get_rate_based_rule_managed_keys_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>RegexMatchSet</a> specified by <code>RegexMatchSetId</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetRegexMatchSet {
    _private: (),
}
impl GetRegexMatchSet {
    /// Creates a new builder-style object to manufacture [`GetRegexMatchSetInput`](crate::input::GetRegexMatchSetInput)
    pub fn builder() -> crate::input::get_regex_match_set_input::Builder {
        crate::input::get_regex_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetRegexMatchSet {
    type Output = std::result::Result<
        crate::output::GetRegexMatchSetOutput,
        crate::error::GetRegexMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_regex_match_set_error(response)
        } else {
            crate::operation_deser::parse_get_regex_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>RegexPatternSet</a> specified by <code>RegexPatternSetId</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetRegexPatternSet {
    _private: (),
}
impl GetRegexPatternSet {
    /// Creates a new builder-style object to manufacture [`GetRegexPatternSetInput`](crate::input::GetRegexPatternSetInput)
    pub fn builder() -> crate::input::get_regex_pattern_set_input::Builder {
        crate::input::get_regex_pattern_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetRegexPatternSet {
    type Output = std::result::Result<
        crate::output::GetRegexPatternSetOutput,
        crate::error::GetRegexPatternSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_regex_pattern_set_error(response)
        } else {
            crate::operation_deser::parse_get_regex_pattern_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>Rule</a> that is specified by the <code>RuleId</code> that you included in the <code>GetRule</code> request.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetRule {
    _private: (),
}
impl GetRule {
    /// Creates a new builder-style object to manufacture [`GetRuleInput`](crate::input::GetRuleInput)
    pub fn builder() -> crate::input::get_rule_input::Builder {
        crate::input::get_rule_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetRule {
    type Output = std::result::Result<crate::output::GetRuleOutput, crate::error::GetRuleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_rule_error(response)
        } else {
            crate::operation_deser::parse_get_rule_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>RuleGroup</a> that is specified by the <code>RuleGroupId</code> that you included in the <code>GetRuleGroup</code> request.</p>
/// <p>To view the rules in a rule group, use <a>ListActivatedRulesInRuleGroup</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetRuleGroup {
    _private: (),
}
impl GetRuleGroup {
    /// Creates a new builder-style object to manufacture [`GetRuleGroupInput`](crate::input::GetRuleGroupInput)
    pub fn builder() -> crate::input::get_rule_group_input::Builder {
        crate::input::get_rule_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetRuleGroup {
    type Output =
        std::result::Result<crate::output::GetRuleGroupOutput, crate::error::GetRuleGroupError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_rule_group_error(response)
        } else {
            crate::operation_deser::parse_get_rule_group_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Gets detailed information about a specified number of requests--a sample--that AWS WAF randomly selects from among the first 5,000 requests that your AWS resource received during a time range that you choose. You can specify a sample size of up to 500 requests, and you can specify any time range in the previous three hours.</p>
/// <p>
/// <code>GetSampledRequests</code> returns a time range, which is usually the time range that you specified. However, if your resource
/// (such as a CloudFront distribution) received 5,000 requests before the specified time range elapsed, <code>GetSampledRequests</code>
/// returns an updated time range. This new time range indicates the actual period during which AWS WAF selected the requests in the sample.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetSampledRequests {
    _private: (),
}
impl GetSampledRequests {
    /// Creates a new builder-style object to manufacture [`GetSampledRequestsInput`](crate::input::GetSampledRequestsInput)
    pub fn builder() -> crate::input::get_sampled_requests_input::Builder {
        crate::input::get_sampled_requests_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetSampledRequests {
    type Output = std::result::Result<
        crate::output::GetSampledRequestsOutput,
        crate::error::GetSampledRequestsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_sampled_requests_error(response)
        } else {
            crate::operation_deser::parse_get_sampled_requests_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>SizeConstraintSet</a> specified by <code>SizeConstraintSetId</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetSizeConstraintSet {
    _private: (),
}
impl GetSizeConstraintSet {
    /// Creates a new builder-style object to manufacture [`GetSizeConstraintSetInput`](crate::input::GetSizeConstraintSetInput)
    pub fn builder() -> crate::input::get_size_constraint_set_input::Builder {
        crate::input::get_size_constraint_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetSizeConstraintSet {
    type Output = std::result::Result<
        crate::output::GetSizeConstraintSetOutput,
        crate::error::GetSizeConstraintSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_size_constraint_set_error(response)
        } else {
            crate::operation_deser::parse_get_size_constraint_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>SqlInjectionMatchSet</a> that is specified by <code>SqlInjectionMatchSetId</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetSqlInjectionMatchSet {
    _private: (),
}
impl GetSqlInjectionMatchSet {
    /// Creates a new builder-style object to manufacture [`GetSqlInjectionMatchSetInput`](crate::input::GetSqlInjectionMatchSetInput)
    pub fn builder() -> crate::input::get_sql_injection_match_set_input::Builder {
        crate::input::get_sql_injection_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetSqlInjectionMatchSet {
    type Output = std::result::Result<
        crate::output::GetSqlInjectionMatchSetOutput,
        crate::error::GetSqlInjectionMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_sql_injection_match_set_error(response)
        } else {
            crate::operation_deser::parse_get_sql_injection_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>WebACL</a> that is specified by <code>WebACLId</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetWebACL {
    _private: (),
}
impl GetWebACL {
    /// Creates a new builder-style object to manufacture [`GetWebAclInput`](crate::input::GetWebAclInput)
    pub fn builder() -> crate::input::get_web_acl_input::Builder {
        crate::input::get_web_acl_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetWebACL {
    type Output = std::result::Result<crate::output::GetWebAclOutput, crate::error::GetWebACLError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_web_acl_error(response)
        } else {
            crate::operation_deser::parse_get_web_acl_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns the <a>XssMatchSet</a> that is specified by <code>XssMatchSetId</code>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct GetXssMatchSet {
    _private: (),
}
impl GetXssMatchSet {
    /// Creates a new builder-style object to manufacture [`GetXssMatchSetInput`](crate::input::GetXssMatchSetInput)
    pub fn builder() -> crate::input::get_xss_match_set_input::Builder {
        crate::input::get_xss_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for GetXssMatchSet {
    type Output =
        std::result::Result<crate::output::GetXssMatchSetOutput, crate::error::GetXssMatchSetError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_get_xss_match_set_error(response)
        } else {
            crate::operation_deser::parse_get_xss_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>ActivatedRule</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListActivatedRulesInRuleGroup {
    _private: (),
}
impl ListActivatedRulesInRuleGroup {
    /// Creates a new builder-style object to manufacture [`ListActivatedRulesInRuleGroupInput`](crate::input::ListActivatedRulesInRuleGroupInput)
    pub fn builder() -> crate::input::list_activated_rules_in_rule_group_input::Builder {
        crate::input::list_activated_rules_in_rule_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListActivatedRulesInRuleGroup {
    type Output = std::result::Result<
        crate::output::ListActivatedRulesInRuleGroupOutput,
        crate::error::ListActivatedRulesInRuleGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_activated_rules_in_rule_group_error(response)
        } else {
            crate::operation_deser::parse_list_activated_rules_in_rule_group_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>ByteMatchSetSummary</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListByteMatchSets {
    _private: (),
}
impl ListByteMatchSets {
    /// Creates a new builder-style object to manufacture [`ListByteMatchSetsInput`](crate::input::ListByteMatchSetsInput)
    pub fn builder() -> crate::input::list_byte_match_sets_input::Builder {
        crate::input::list_byte_match_sets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListByteMatchSets {
    type Output = std::result::Result<
        crate::output::ListByteMatchSetsOutput,
        crate::error::ListByteMatchSetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_byte_match_sets_error(response)
        } else {
            crate::operation_deser::parse_list_byte_match_sets_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>GeoMatchSetSummary</a> objects in the response.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListGeoMatchSets {
    _private: (),
}
impl ListGeoMatchSets {
    /// Creates a new builder-style object to manufacture [`ListGeoMatchSetsInput`](crate::input::ListGeoMatchSetsInput)
    pub fn builder() -> crate::input::list_geo_match_sets_input::Builder {
        crate::input::list_geo_match_sets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListGeoMatchSets {
    type Output = std::result::Result<
        crate::output::ListGeoMatchSetsOutput,
        crate::error::ListGeoMatchSetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_geo_match_sets_error(response)
        } else {
            crate::operation_deser::parse_list_geo_match_sets_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>IPSetSummary</a> objects in the response.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListIPSets {
    _private: (),
}
impl ListIPSets {
    /// Creates a new builder-style object to manufacture [`ListIpSetsInput`](crate::input::ListIpSetsInput)
    pub fn builder() -> crate::input::list_ip_sets_input::Builder {
        crate::input::list_ip_sets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListIPSets {
    type Output =
        std::result::Result<crate::output::ListIpSetsOutput, crate::error::ListIPSetsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_ip_sets_error(response)
        } else {
            crate::operation_deser::parse_list_ip_sets_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>LoggingConfiguration</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListLoggingConfigurations {
    _private: (),
}
impl ListLoggingConfigurations {
    /// Creates a new builder-style object to manufacture [`ListLoggingConfigurationsInput`](crate::input::ListLoggingConfigurationsInput)
    pub fn builder() -> crate::input::list_logging_configurations_input::Builder {
        crate::input::list_logging_configurations_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListLoggingConfigurations {
    type Output = std::result::Result<
        crate::output::ListLoggingConfigurationsOutput,
        crate::error::ListLoggingConfigurationsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_logging_configurations_error(response)
        } else {
            crate::operation_deser::parse_list_logging_configurations_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>RuleSummary</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListRateBasedRules {
    _private: (),
}
impl ListRateBasedRules {
    /// Creates a new builder-style object to manufacture [`ListRateBasedRulesInput`](crate::input::ListRateBasedRulesInput)
    pub fn builder() -> crate::input::list_rate_based_rules_input::Builder {
        crate::input::list_rate_based_rules_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListRateBasedRules {
    type Output = std::result::Result<
        crate::output::ListRateBasedRulesOutput,
        crate::error::ListRateBasedRulesError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_rate_based_rules_error(response)
        } else {
            crate::operation_deser::parse_list_rate_based_rules_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>RegexMatchSetSummary</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListRegexMatchSets {
    _private: (),
}
impl ListRegexMatchSets {
    /// Creates a new builder-style object to manufacture [`ListRegexMatchSetsInput`](crate::input::ListRegexMatchSetsInput)
    pub fn builder() -> crate::input::list_regex_match_sets_input::Builder {
        crate::input::list_regex_match_sets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListRegexMatchSets {
    type Output = std::result::Result<
        crate::output::ListRegexMatchSetsOutput,
        crate::error::ListRegexMatchSetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_regex_match_sets_error(response)
        } else {
            crate::operation_deser::parse_list_regex_match_sets_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>RegexPatternSetSummary</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListRegexPatternSets {
    _private: (),
}
impl ListRegexPatternSets {
    /// Creates a new builder-style object to manufacture [`ListRegexPatternSetsInput`](crate::input::ListRegexPatternSetsInput)
    pub fn builder() -> crate::input::list_regex_pattern_sets_input::Builder {
        crate::input::list_regex_pattern_sets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListRegexPatternSets {
    type Output = std::result::Result<
        crate::output::ListRegexPatternSetsOutput,
        crate::error::ListRegexPatternSetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_regex_pattern_sets_error(response)
        } else {
            crate::operation_deser::parse_list_regex_pattern_sets_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>RuleGroup</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListRuleGroups {
    _private: (),
}
impl ListRuleGroups {
    /// Creates a new builder-style object to manufacture [`ListRuleGroupsInput`](crate::input::ListRuleGroupsInput)
    pub fn builder() -> crate::input::list_rule_groups_input::Builder {
        crate::input::list_rule_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListRuleGroups {
    type Output =
        std::result::Result<crate::output::ListRuleGroupsOutput, crate::error::ListRuleGroupsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_rule_groups_error(response)
        } else {
            crate::operation_deser::parse_list_rule_groups_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>RuleSummary</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListRules {
    _private: (),
}
impl ListRules {
    /// Creates a new builder-style object to manufacture [`ListRulesInput`](crate::input::ListRulesInput)
    pub fn builder() -> crate::input::list_rules_input::Builder {
        crate::input::list_rules_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListRules {
    type Output = std::result::Result<crate::output::ListRulesOutput, crate::error::ListRulesError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_rules_error(response)
        } else {
            crate::operation_deser::parse_list_rules_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>SizeConstraintSetSummary</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListSizeConstraintSets {
    _private: (),
}
impl ListSizeConstraintSets {
    /// Creates a new builder-style object to manufacture [`ListSizeConstraintSetsInput`](crate::input::ListSizeConstraintSetsInput)
    pub fn builder() -> crate::input::list_size_constraint_sets_input::Builder {
        crate::input::list_size_constraint_sets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListSizeConstraintSets {
    type Output = std::result::Result<
        crate::output::ListSizeConstraintSetsOutput,
        crate::error::ListSizeConstraintSetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_size_constraint_sets_error(response)
        } else {
            crate::operation_deser::parse_list_size_constraint_sets_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>SqlInjectionMatchSet</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListSqlInjectionMatchSets {
    _private: (),
}
impl ListSqlInjectionMatchSets {
    /// Creates a new builder-style object to manufacture [`ListSqlInjectionMatchSetsInput`](crate::input::ListSqlInjectionMatchSetsInput)
    pub fn builder() -> crate::input::list_sql_injection_match_sets_input::Builder {
        crate::input::list_sql_injection_match_sets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListSqlInjectionMatchSets {
    type Output = std::result::Result<
        crate::output::ListSqlInjectionMatchSetsOutput,
        crate::error::ListSqlInjectionMatchSetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_sql_injection_match_sets_error(response)
        } else {
            crate::operation_deser::parse_list_sql_injection_match_sets_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>RuleGroup</a> objects that you are subscribed to.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListSubscribedRuleGroups {
    _private: (),
}
impl ListSubscribedRuleGroups {
    /// Creates a new builder-style object to manufacture [`ListSubscribedRuleGroupsInput`](crate::input::ListSubscribedRuleGroupsInput)
    pub fn builder() -> crate::input::list_subscribed_rule_groups_input::Builder {
        crate::input::list_subscribed_rule_groups_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListSubscribedRuleGroups {
    type Output = std::result::Result<
        crate::output::ListSubscribedRuleGroupsOutput,
        crate::error::ListSubscribedRuleGroupsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_subscribed_rule_groups_error(response)
        } else {
            crate::operation_deser::parse_list_subscribed_rule_groups_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Retrieves the tags associated with the specified AWS resource. Tags are key:value pairs that you can use to categorize and manage your resources, for purposes like billing. For example, you might set the tag key to "customer" and the value to the customer name or ID. You can specify one or more tags to add to each AWS resource, up to 50 tags for a resource.</p>
/// <p>Tagging is only available through the API, SDKs, and CLI. You can't manage or view tags through the AWS WAF Classic console. You can tag the AWS resources that you manage through AWS WAF Classic: web ACLs, rule groups, and rules.  </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListTagsForResource {
    _private: (),
}
impl ListTagsForResource {
    /// Creates a new builder-style object to manufacture [`ListTagsForResourceInput`](crate::input::ListTagsForResourceInput)
    pub fn builder() -> crate::input::list_tags_for_resource_input::Builder {
        crate::input::list_tags_for_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListTagsForResource {
    type Output = std::result::Result<
        crate::output::ListTagsForResourceOutput,
        crate::error::ListTagsForResourceError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_tags_for_resource_error(response)
        } else {
            crate::operation_deser::parse_list_tags_for_resource_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>WebACLSummary</a> objects in the response.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListWebACLs {
    _private: (),
}
impl ListWebACLs {
    /// Creates a new builder-style object to manufacture [`ListWebAcLsInput`](crate::input::ListWebAcLsInput)
    pub fn builder() -> crate::input::list_web_ac_ls_input::Builder {
        crate::input::list_web_ac_ls_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListWebACLs {
    type Output =
        std::result::Result<crate::output::ListWebAcLsOutput, crate::error::ListWebACLsError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_web_ac_ls_error(response)
        } else {
            crate::operation_deser::parse_list_web_ac_ls_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Returns an array of <a>XssMatchSet</a> objects.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct ListXssMatchSets {
    _private: (),
}
impl ListXssMatchSets {
    /// Creates a new builder-style object to manufacture [`ListXssMatchSetsInput`](crate::input::ListXssMatchSetsInput)
    pub fn builder() -> crate::input::list_xss_match_sets_input::Builder {
        crate::input::list_xss_match_sets_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for ListXssMatchSets {
    type Output = std::result::Result<
        crate::output::ListXssMatchSetsOutput,
        crate::error::ListXssMatchSetsError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_list_xss_match_sets_error(response)
        } else {
            crate::operation_deser::parse_list_xss_match_sets_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Associates a <a>LoggingConfiguration</a> with a specified web ACL.</p>
/// <p>You can access information about all traffic that AWS WAF inspects using the following
/// steps:</p>
/// <ol>
/// <li>
/// <p>Create an Amazon Kinesis Data
/// Firehose. </p>
/// <p>Create the data firehose with a PUT source and in the region that you are operating. However, if you are capturing logs for Amazon CloudFront, always create the firehose in US East (N. Virginia). </p>
/// <note>
/// <p>Do not create the data firehose using a <code>Kinesis stream</code> as your source.</p>
/// </note>
/// </li>
/// <li>
/// <p>Associate that firehose to your web ACL using a <code>PutLoggingConfiguration</code> request.</p>
/// </li>
/// </ol>
/// <p>When you successfully enable logging using a <code>PutLoggingConfiguration</code> request, AWS WAF will create a service linked role with the necessary permissions to write logs to the Amazon Kinesis Data Firehose.  For more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/logging.html">Logging Web ACL Traffic Information</a> in the <i>AWS WAF Developer Guide</i>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutLoggingConfiguration {
    _private: (),
}
impl PutLoggingConfiguration {
    /// Creates a new builder-style object to manufacture [`PutLoggingConfigurationInput`](crate::input::PutLoggingConfigurationInput)
    pub fn builder() -> crate::input::put_logging_configuration_input::Builder {
        crate::input::put_logging_configuration_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutLoggingConfiguration {
    type Output = std::result::Result<
        crate::output::PutLoggingConfigurationOutput,
        crate::error::PutLoggingConfigurationError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_logging_configuration_error(response)
        } else {
            crate::operation_deser::parse_put_logging_configuration_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Attaches an IAM policy to the specified resource. The only supported use for this action is to share a RuleGroup across accounts.</p>
/// <p>The <code>PutPermissionPolicy</code> is subject to the following restrictions:</p>
/// <ul>
/// <li>
/// <p>You can attach only one policy with each <code>PutPermissionPolicy</code> request.</p>
/// </li>
/// <li>
/// <p>The policy must include an <code>Effect</code>, <code>Action</code> and <code>Principal</code>. </p>
/// </li>
/// <li>
/// <p>
/// <code>Effect</code> must specify <code>Allow</code>.</p>
/// </li>
/// <li>
/// <p>The <code>Action</code> in the policy must be <code>waf:UpdateWebACL</code>, <code>waf-regional:UpdateWebACL</code>, <code>waf:GetRuleGroup</code> and <code>waf-regional:GetRuleGroup</code> . Any extra or wildcard actions in the policy will be rejected.</p>
/// </li>
/// <li>
/// <p>The policy cannot include a <code>Resource</code> parameter.</p>
/// </li>
/// <li>
/// <p>The ARN in the request must be a valid WAF RuleGroup ARN and the RuleGroup must exist in the same region.</p>
/// </li>
/// <li>
/// <p>The user making the request must be the owner of the RuleGroup.</p>
/// </li>
/// <li>
/// <p>Your policy must be composed using IAM Policy version 2012-10-17.</p>
/// </li>
/// </ul>     
/// <p>For more information, see <a href="https://docs.aws.amazon.com/IAM/latest/UserGuide/access_policies.html">IAM Policies</a>.  </p>  
/// <p>An example of a valid policy parameter is shown in the Examples section below.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct PutPermissionPolicy {
    _private: (),
}
impl PutPermissionPolicy {
    /// Creates a new builder-style object to manufacture [`PutPermissionPolicyInput`](crate::input::PutPermissionPolicyInput)
    pub fn builder() -> crate::input::put_permission_policy_input::Builder {
        crate::input::put_permission_policy_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for PutPermissionPolicy {
    type Output = std::result::Result<
        crate::output::PutPermissionPolicyOutput,
        crate::error::PutPermissionPolicyError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_put_permission_policy_error(response)
        } else {
            crate::operation_deser::parse_put_permission_policy_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Associates tags with the specified AWS resource. Tags are key:value pairs that you can use to categorize and manage your resources, for purposes like billing. For example, you might set the tag key to "customer" and the value to the customer name or ID. You can specify one or more tags to add to each AWS resource, up to 50 tags for a resource.</p>
/// <p>Tagging is only available through the API, SDKs, and CLI. You can't manage or view tags through the AWS WAF Classic console. You can use this action to tag the AWS resources that you manage through AWS WAF Classic: web ACLs, rule groups, and rules.  </p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct TagResource {
    _private: (),
}
impl TagResource {
    /// Creates a new builder-style object to manufacture [`TagResourceInput`](crate::input::TagResourceInput)
    pub fn builder() -> crate::input::tag_resource_input::Builder {
        crate::input::tag_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for TagResource {
    type Output =
        std::result::Result<crate::output::TagResourceOutput, crate::error::TagResourceError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_tag_resource_error(response)
        } else {
            crate::operation_deser::parse_tag_resource_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p></p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UntagResource {
    _private: (),
}
impl UntagResource {
    /// Creates a new builder-style object to manufacture [`UntagResourceInput`](crate::input::UntagResourceInput)
    pub fn builder() -> crate::input::untag_resource_input::Builder {
        crate::input::untag_resource_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UntagResource {
    type Output =
        std::result::Result<crate::output::UntagResourceOutput, crate::error::UntagResourceError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_untag_resource_error(response)
        } else {
            crate::operation_deser::parse_untag_resource_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>ByteMatchTuple</a> objects (filters) in a <a>ByteMatchSet</a>. For each <code>ByteMatchTuple</code> object,
/// you specify the following values: </p>
/// <ul>
/// <li>
/// <p>Whether to insert or delete the object from the array. If you want to change a <code>ByteMatchSetUpdate</code> object,
/// you delete the existing object and add a new one.</p>
/// </li>
/// <li>
/// <p>The part of a web request that you want AWS WAF to inspect, such as a query string or the value of the <code>User-Agent</code> header. </p>
/// </li>
/// <li>
/// <p>The bytes (typically a string that corresponds with ASCII characters) that you want AWS WAF to look for. For more information, including how you specify  
/// the values for the AWS WAF API and the AWS CLI or SDKs, see <code>TargetString</code> in the <a>ByteMatchTuple</a> data type. </p>
/// </li>
/// <li>
/// <p>Where to look, such as at the beginning or the end of a query string.</p>
/// </li>
/// <li>
/// <p>Whether to perform any conversions on the request, such as converting it to lowercase, before inspecting it for the specified string.</p>
/// </li>
/// </ul>
/// <p>For example, you can add a <code>ByteMatchSetUpdate</code> object that matches web requests in which <code>User-Agent</code> headers contain
/// the string <code>BadBot</code>. You can then configure AWS WAF to block those requests.</p>    
/// <p>To create and configure a <code>ByteMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Create a <code>ByteMatchSet.</code> For more information, see <a>CreateByteMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <code>UpdateByteMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateByteMatchSet</code> request to specify the part of the request that you want AWS WAF to inspect
/// (for example, the header or the URI) and the value that you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateByteMatchSet {
    _private: (),
}
impl UpdateByteMatchSet {
    /// Creates a new builder-style object to manufacture [`UpdateByteMatchSetInput`](crate::input::UpdateByteMatchSetInput)
    pub fn builder() -> crate::input::update_byte_match_set_input::Builder {
        crate::input::update_byte_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateByteMatchSet {
    type Output = std::result::Result<
        crate::output::UpdateByteMatchSetOutput,
        crate::error::UpdateByteMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_byte_match_set_error(response)
        } else {
            crate::operation_deser::parse_update_byte_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>GeoMatchConstraint</a> objects in an <code>GeoMatchSet</code>. For each <code>GeoMatchConstraint</code> object,
/// you specify the following values: </p>
/// <ul>
/// <li>
/// <p>Whether to insert or delete the object from the array. If you want to change an <code>GeoMatchConstraint</code> object, you delete the existing object and add a new one.</p>
/// </li>
/// <li>
/// <p>The <code>Type</code>. The only valid value for <code>Type</code> is <code>Country</code>.</p>
/// </li>
/// <li>
/// <p>The <code>Value</code>, which is a two character code for the country to add to the <code>GeoMatchConstraint</code> object. Valid codes are listed in <a>GeoMatchConstraint$Value</a>.</p>
/// </li>
/// </ul>
/// <p>To create and configure an <code>GeoMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Submit a <a>CreateGeoMatchSet</a> request.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateGeoMatchSet</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateGeoMatchSet</code> request to specify the country that you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>When you update an <code>GeoMatchSet</code>, you specify the country that you want to add and/or the country that you want to delete.
/// If you want to change a country, you delete the existing country and add the new one.</p>    
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateGeoMatchSet {
    _private: (),
}
impl UpdateGeoMatchSet {
    /// Creates a new builder-style object to manufacture [`UpdateGeoMatchSetInput`](crate::input::UpdateGeoMatchSetInput)
    pub fn builder() -> crate::input::update_geo_match_set_input::Builder {
        crate::input::update_geo_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateGeoMatchSet {
    type Output = std::result::Result<
        crate::output::UpdateGeoMatchSetOutput,
        crate::error::UpdateGeoMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_geo_match_set_error(response)
        } else {
            crate::operation_deser::parse_update_geo_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>IPSetDescriptor</a> objects in an
/// <code>IPSet</code>. For each <code>IPSetDescriptor</code> object, you specify the following
/// values: </p>
/// <ul>
/// <li>
/// <p>Whether to insert or delete the object from the array. If you want to change an
/// <code>IPSetDescriptor</code> object, you delete the existing object and add a new
/// one.</p>
/// </li>
/// <li>
/// <p>The IP address version, <code>IPv4</code> or <code>IPv6</code>. </p>
/// </li>
/// <li>
/// <p>The IP address in CIDR notation, for example, <code>192.0.2.0/24</code> (for
/// the range of IP addresses from <code>192.0.2.0</code> to <code>192.0.2.255</code>) or
/// <code>192.0.2.44/32</code> (for the individual IP address
/// <code>192.0.2.44</code>). </p>
/// </li>
/// </ul>
/// <p>AWS WAF supports IPv4 address ranges: /8 and any range between /16 through /32. AWS
/// WAF supports IPv6 address ranges: /24, /32, /48, /56, /64, and /128. For more
/// information about CIDR notation, see the Wikipedia entry <a href="https://en.wikipedia.org/wiki/Classless_Inter-Domain_Routing">Classless
/// Inter-Domain Routing</a>.</p>
/// <p>IPv6 addresses can be represented using any of the following formats:</p>
/// <ul>
/// <li>
/// <p>1111:0000:0000:0000:0000:0000:0000:0111/128</p>
/// </li>
/// <li>
/// <p>1111:0:0:0:0:0:0:0111/128</p>
/// </li>
/// <li>
/// <p>1111::0111/128</p>
/// </li>
/// <li>
/// <p>1111::111/128</p>
/// </li>
/// </ul>
/// <p>You use an <code>IPSet</code> to specify which web requests you want to allow or
/// block based on the IP addresses that the requests originated from. For example, if you're
/// receiving a lot of requests from one or a small number of IP addresses and you want to
/// block the requests, you can create an <code>IPSet</code> that specifies those IP addresses,
/// and then configure AWS WAF to block the requests. </p>
/// <p>To create and configure an <code>IPSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Submit a <a>CreateIPSet</a> request.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide
/// in the <code>ChangeToken</code> parameter of an <a>UpdateIPSet</a>
/// request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateIPSet</code> request to specify the IP addresses that you
/// want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>When you update an <code>IPSet</code>, you specify the IP addresses that you want to
/// add and/or the IP addresses that you want to delete. If you want to change an IP address,
/// you delete the existing IP address and add the new one.</p>
/// <p>You can insert a maximum of 1000 addresses in a single
/// request.</p>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP
/// requests, see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF
/// Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateIPSet {
    _private: (),
}
impl UpdateIPSet {
    /// Creates a new builder-style object to manufacture [`UpdateIpSetInput`](crate::input::UpdateIpSetInput)
    pub fn builder() -> crate::input::update_ip_set_input::Builder {
        crate::input::update_ip_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateIPSet {
    type Output =
        std::result::Result<crate::output::UpdateIpSetOutput, crate::error::UpdateIPSetError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_ip_set_error(response)
        } else {
            crate::operation_deser::parse_update_ip_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>Predicate</a> objects in a rule and updates the
/// <code>RateLimit</code> in the rule. </p>
/// <p>Each <code>Predicate</code> object identifies a predicate, such as a <a>ByteMatchSet</a> or an <a>IPSet</a>, that specifies the web requests
/// that you want to block or count. The <code>RateLimit</code> specifies the number of
/// requests every five minutes that triggers the rule.</p>
/// <p>If you add more than one predicate to a <code>RateBasedRule</code>, a request must
/// match all the predicates and exceed the <code>RateLimit</code> to be counted or blocked.
/// For example, suppose you add the following to a <code>RateBasedRule</code>:</p>
/// <ul>
/// <li>
/// <p>An <code>IPSet</code> that matches the IP address <code>192.0.2.44/32</code>
/// </p>
/// </li>
/// <li>
/// <p>A <code>ByteMatchSet</code> that matches <code>BadBot</code> in the
/// <code>User-Agent</code> header</p>
/// </li>
/// </ul>
/// <p>Further, you specify a
/// <code>RateLimit</code> of 1,000.</p>
/// <p>You then add the <code>RateBasedRule</code> to a <code>WebACL</code> and specify that
/// you want to block requests that satisfy the rule. For a request to be blocked, it must come
/// from the IP address 192.0.2.44 <i>and</i> the <code>User-Agent</code> header
/// in the request must contain the value <code>BadBot</code>. Further, requests that match
/// these two conditions much be received at a rate of more than 1,000 every five minutes. If
/// the rate drops below this limit, AWS WAF no longer blocks the requests.</p>
/// <p>As a second example, suppose you want to limit requests to a particular page on your site. To do this, you could add the following to a
/// <code>RateBasedRule</code>:</p>
/// <ul>
/// <li>
/// <p>A <code>ByteMatchSet</code> with <code>FieldToMatch</code> of <code>URI</code>
/// </p>
/// </li>
/// <li>
/// <p>A <code>PositionalConstraint</code> of <code>STARTS_WITH</code>
/// </p>
/// </li>
/// <li>
/// <p>A <code>TargetString</code> of <code>login</code>
/// </p>
/// </li>
/// </ul>
/// <p>Further, you specify a <code>RateLimit</code> of 1,000.</p>
/// <p>By adding this <code>RateBasedRule</code> to a <code>WebACL</code>, you could limit requests to your login page without affecting the rest of your site.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateRateBasedRule {
    _private: (),
}
impl UpdateRateBasedRule {
    /// Creates a new builder-style object to manufacture [`UpdateRateBasedRuleInput`](crate::input::UpdateRateBasedRuleInput)
    pub fn builder() -> crate::input::update_rate_based_rule_input::Builder {
        crate::input::update_rate_based_rule_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateRateBasedRule {
    type Output = std::result::Result<
        crate::output::UpdateRateBasedRuleOutput,
        crate::error::UpdateRateBasedRuleError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_rate_based_rule_error(response)
        } else {
            crate::operation_deser::parse_update_rate_based_rule_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>RegexMatchTuple</a> objects (filters) in a <a>RegexMatchSet</a>. For each <code>RegexMatchSetUpdate</code> object,
/// you specify the following values: </p>
/// <ul>
/// <li>
/// <p>Whether to insert or delete the object from the array. If you want to change a <code>RegexMatchSetUpdate</code> object,
/// you delete the existing object and add a new one.</p>
/// </li>
/// <li>
/// <p>The part of a web request that you want AWS WAF to inspectupdate, such as a query string or the value of the <code>User-Agent</code> header. </p>
/// </li>
/// <li>
/// <p>The identifier of the pattern (a regular expression) that you want AWS WAF to look for. For more information, see <a>RegexPatternSet</a>. </p>
/// </li>
/// <li>
/// <p>Whether to perform any conversions on the request, such as converting it to lowercase, before inspecting it for the specified string.</p>
/// </li>
/// </ul>
/// <p> For example, you can create a <code>RegexPatternSet</code> that matches any requests with <code>User-Agent</code> headers
/// that contain the string <code>B[a@]dB[o0]t</code>. You can then configure AWS WAF to reject those requests.</p>    
/// <p>To create and configure a <code>RegexMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Create a <code>RegexMatchSet.</code> For more information, see <a>CreateRegexMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <code>UpdateRegexMatchSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateRegexMatchSet</code> request to specify the part of the request that you want AWS WAF to inspect
/// (for example, the header or the URI) and the identifier of the <code>RegexPatternSet</code> that contain the regular expression patters you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateRegexMatchSet {
    _private: (),
}
impl UpdateRegexMatchSet {
    /// Creates a new builder-style object to manufacture [`UpdateRegexMatchSetInput`](crate::input::UpdateRegexMatchSetInput)
    pub fn builder() -> crate::input::update_regex_match_set_input::Builder {
        crate::input::update_regex_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateRegexMatchSet {
    type Output = std::result::Result<
        crate::output::UpdateRegexMatchSetOutput,
        crate::error::UpdateRegexMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_regex_match_set_error(response)
        } else {
            crate::operation_deser::parse_update_regex_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <code>RegexPatternString</code> objects in a <a>RegexPatternSet</a>. For each <code>RegexPatternString</code> object,
/// you specify the following values: </p>
/// <ul>
/// <li>
/// <p>Whether to insert or delete the <code>RegexPatternString</code>.</p>
/// </li>
/// <li>
/// <p>The regular expression pattern that you want to insert or delete. For more information, see <a>RegexPatternSet</a>. </p>
/// </li>
/// </ul>
/// <p> For example, you can create a <code>RegexPatternString</code> such as <code>B[a@]dB[o0]t</code>. AWS WAF will match this <code>RegexPatternString</code> to:</p>
/// <ul>
/// <li>
/// <p>BadBot</p>
/// </li>
/// <li>
/// <p>BadB0t</p>
/// </li>
/// <li>
/// <p>B@dBot</p>
/// </li>
/// <li>
/// <p>B@dB0t</p>
/// </li>
/// </ul>
/// <p>To create and configure a <code>RegexPatternSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Create a <code>RegexPatternSet.</code> For more information, see <a>CreateRegexPatternSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <code>UpdateRegexPatternSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateRegexPatternSet</code> request to specify the regular expression pattern that you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateRegexPatternSet {
    _private: (),
}
impl UpdateRegexPatternSet {
    /// Creates a new builder-style object to manufacture [`UpdateRegexPatternSetInput`](crate::input::UpdateRegexPatternSetInput)
    pub fn builder() -> crate::input::update_regex_pattern_set_input::Builder {
        crate::input::update_regex_pattern_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateRegexPatternSet {
    type Output = std::result::Result<
        crate::output::UpdateRegexPatternSetOutput,
        crate::error::UpdateRegexPatternSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_regex_pattern_set_error(response)
        } else {
            crate::operation_deser::parse_update_regex_pattern_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>Predicate</a> objects in a <code>Rule</code>. Each
/// <code>Predicate</code> object identifies a predicate, such as a <a>ByteMatchSet</a> or an <a>IPSet</a>, that specifies the web requests
/// that you want to allow, block, or count. If you add more than one predicate to a
/// <code>Rule</code>, a request must match all of the specifications to be allowed,
/// blocked, or counted. For example, suppose
/// that
/// you add the following to a <code>Rule</code>: </p>    
/// <ul>
/// <li>
/// <p>A <code>ByteMatchSet</code> that matches the value <code>BadBot</code> in the <code>User-Agent</code> header</p>
/// </li>
/// <li>
/// <p>An <code>IPSet</code> that matches the IP address <code>192.0.2.44</code>
/// </p>
/// </li>
/// </ul>    
/// <p>You then add the <code>Rule</code> to a <code>WebACL</code> and specify that you want to block requests that satisfy the <code>Rule</code>.
/// For a request to be blocked, the <code>User-Agent</code> header in the request must contain the value <code>BadBot</code>
/// <i>and</i> the request must originate from the IP address 192.0.2.44.</p>    
/// <p>To create and configure a <code>Rule</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Create and update the predicates that you want to include in the <code>Rule</code>.</p>
/// </li>
/// <li>
/// <p>Create the <code>Rule</code>. See <a>CreateRule</a>.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateRule</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateRule</code> request to add predicates to the <code>Rule</code>.</p>
/// </li>
/// <li>
/// <p>Create and update a <code>WebACL</code> that contains the <code>Rule</code>. See <a>CreateWebACL</a>.</p>
/// </li>
/// </ol>
/// <p>If you want to replace one <code>ByteMatchSet</code> or <code>IPSet</code> with another, you delete the existing one and
/// add the new one.</p>    
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateRule {
    _private: (),
}
impl UpdateRule {
    /// Creates a new builder-style object to manufacture [`UpdateRuleInput`](crate::input::UpdateRuleInput)
    pub fn builder() -> crate::input::update_rule_input::Builder {
        crate::input::update_rule_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateRule {
    type Output =
        std::result::Result<crate::output::UpdateRuleOutput, crate::error::UpdateRuleError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_rule_error(response)
        } else {
            crate::operation_deser::parse_update_rule_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>ActivatedRule</a> objects in a <code>RuleGroup</code>.</p>
/// <p>You can only insert <code>REGULAR</code> rules into a rule group.</p>
/// <p>You can have a maximum of ten rules per rule group.</p>
/// <p>To create and configure a <code>RuleGroup</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Create and update the <code>Rules</code> that you want to include in the <code>RuleGroup</code>. See <a>CreateRule</a>.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateRuleGroup</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateRuleGroup</code> request to add <code>Rules</code> to the <code>RuleGroup</code>.</p>
/// </li>
/// <li>
/// <p>Create and update a <code>WebACL</code> that contains the <code>RuleGroup</code>. See <a>CreateWebACL</a>.</p>
/// </li>
/// </ol>
/// <p>If you want to replace one <code>Rule</code> with another, you delete the existing one and
/// add the new one.</p>    
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateRuleGroup {
    _private: (),
}
impl UpdateRuleGroup {
    /// Creates a new builder-style object to manufacture [`UpdateRuleGroupInput`](crate::input::UpdateRuleGroupInput)
    pub fn builder() -> crate::input::update_rule_group_input::Builder {
        crate::input::update_rule_group_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateRuleGroup {
    type Output = std::result::Result<
        crate::output::UpdateRuleGroupOutput,
        crate::error::UpdateRuleGroupError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_rule_group_error(response)
        } else {
            crate::operation_deser::parse_update_rule_group_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>SizeConstraint</a> objects (filters) in a <a>SizeConstraintSet</a>. For each <code>SizeConstraint</code> object,
/// you specify the following values: </p>
/// <ul>
/// <li>
/// <p>Whether to insert or delete the object from the array. If you want to change a <code>SizeConstraintSetUpdate</code> object,
/// you delete the existing object and add a new one.</p>
/// </li>
/// <li>
/// <p>The part of a web request that you want AWS WAF to evaluate, such as the length of a query string or the length of the
/// <code>User-Agent</code> header.</p>
/// </li>
/// <li>
/// <p>Whether to perform any transformations on the request, such as converting it to lowercase, before checking its length.
/// Note that transformations of the request body are not supported because the AWS resource forwards only the first <code>8192</code> bytes
/// of your request to AWS WAF.</p>
/// <p>You can only specify a single type of TextTransformation.</p>
/// </li>
/// <li>
/// <p>A <code>ComparisonOperator</code> used for evaluating the selected part of the request against the specified <code>Size</code>, such as  
/// equals, greater than, less than, and so on.</p>
/// </li>
/// <li>
/// <p>The length, in bytes, that you want AWS WAF to watch for in selected part of the request. The length is computed after applying the transformation.</p>
/// </li>
/// </ul>
/// <p>For example, you can add a <code>SizeConstraintSetUpdate</code> object that matches web requests in which the length of the
/// <code>User-Agent</code> header is greater than 100 bytes. You can then configure AWS WAF to block those requests.</p>
/// <p>To create and configure a <code>SizeConstraintSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Create a <code>SizeConstraintSet.</code> For more information, see <a>CreateSizeConstraintSet</a>.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <code>UpdateSizeConstraintSet</code> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateSizeConstraintSet</code> request to specify the part of the request that you want AWS WAF to inspect
/// (for example, the header or the URI) and the value that you want AWS WAF to watch for.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateSizeConstraintSet {
    _private: (),
}
impl UpdateSizeConstraintSet {
    /// Creates a new builder-style object to manufacture [`UpdateSizeConstraintSetInput`](crate::input::UpdateSizeConstraintSetInput)
    pub fn builder() -> crate::input::update_size_constraint_set_input::Builder {
        crate::input::update_size_constraint_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateSizeConstraintSet {
    type Output = std::result::Result<
        crate::output::UpdateSizeConstraintSetOutput,
        crate::error::UpdateSizeConstraintSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_size_constraint_set_error(response)
        } else {
            crate::operation_deser::parse_update_size_constraint_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>SqlInjectionMatchTuple</a> objects (filters) in a <a>SqlInjectionMatchSet</a>.
/// For each <code>SqlInjectionMatchTuple</code> object, you specify the following values:</p>
/// <ul>
/// <li>
/// <p>
/// <code>Action</code>: Whether to insert the object into or delete the object from the array. To change a
/// <code>SqlInjectionMatchTuple</code>, you delete the existing object and add a new one.</p>
/// </li>
/// <li>
/// <p>
/// <code>FieldToMatch</code>: The part of web requests that you want AWS WAF to inspect and, if you want AWS WAF to inspect a header or custom query parameter,
/// the name of the header or parameter.</p>
/// </li>
/// <li>
/// <p>
/// <code>TextTransformation</code>: Which text transformation, if any, to perform on the web request before
/// inspecting the request for snippets of malicious SQL code.</p>
/// <p>You can only specify a single type of  TextTransformation.</p>
/// </li>
/// </ul>
/// <p>You use <code>SqlInjectionMatchSet</code> objects to specify which CloudFront
/// requests that
/// you want to allow, block, or count. For example, if you're receiving
/// requests that contain snippets of SQL code in the query string and you want to block the
/// requests, you can create a <code>SqlInjectionMatchSet</code> with the applicable settings,
/// and then configure AWS WAF to block the requests. </p>
/// <p>To create and configure a <code>SqlInjectionMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Submit a <a>CreateSqlInjectionMatchSet</a> request.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateIPSet</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateSqlInjectionMatchSet</code> request to specify the parts of web requests that you want AWS WAF to
/// inspect for snippets of SQL code.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateSqlInjectionMatchSet {
    _private: (),
}
impl UpdateSqlInjectionMatchSet {
    /// Creates a new builder-style object to manufacture [`UpdateSqlInjectionMatchSetInput`](crate::input::UpdateSqlInjectionMatchSetInput)
    pub fn builder() -> crate::input::update_sql_injection_match_set_input::Builder {
        crate::input::update_sql_injection_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateSqlInjectionMatchSet {
    type Output = std::result::Result<
        crate::output::UpdateSqlInjectionMatchSetOutput,
        crate::error::UpdateSqlInjectionMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_sql_injection_match_set_error(response)
        } else {
            crate::operation_deser::parse_update_sql_injection_match_set_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>ActivatedRule</a> objects in a <code>WebACL</code>. Each <code>Rule</code> identifies
/// web requests that you want to allow, block, or count. When you update a <code>WebACL</code>, you specify the following values:</p>
/// <ul>
/// <li>
/// <p>A default action for the <code>WebACL</code>, either <code>ALLOW</code> or <code>BLOCK</code>.
/// AWS WAF performs the default action if a request doesn't match the criteria in any of the <code>Rules</code> in a <code>WebACL</code>.</p>
/// </li>
/// <li>
/// <p>The <code>Rules</code> that you want to add
/// or
/// delete. If you want to replace one <code>Rule</code> with another, you delete the
/// existing <code>Rule</code> and add the new one.</p>
/// </li>
/// <li>
/// <p>For each <code>Rule</code>, whether you want AWS WAF to allow requests, block requests, or count requests that match
/// the conditions in the <code>Rule</code>.</p>
/// </li>
/// <li>
/// <p>The order in which you want AWS WAF to evaluate the <code>Rules</code> in a
/// <code>WebACL</code>. If you add more than one <code>Rule</code> to a
/// <code>WebACL</code>, AWS WAF evaluates each request against the <code>Rules</code>
/// in order based on the value of <code>Priority</code>. (The <code>Rule</code> that has
/// the lowest value for <code>Priority</code> is evaluated first.) When a web request
/// matches all
/// the
/// predicates (such as <code>ByteMatchSets</code> and <code>IPSets</code>) in a
/// <code>Rule</code>, AWS WAF immediately takes the corresponding action, allow or
/// block, and doesn't evaluate the request against the remaining <code>Rules</code> in
/// the <code>WebACL</code>, if any. </p>
/// </li>
/// </ul>
/// <p>To create and configure a <code>WebACL</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Create and update the predicates that you want to include in <code>Rules</code>.
/// For more information, see <a>CreateByteMatchSet</a>, <a>UpdateByteMatchSet</a>, <a>CreateIPSet</a>, <a>UpdateIPSet</a>,
/// <a>CreateSqlInjectionMatchSet</a>, and <a>UpdateSqlInjectionMatchSet</a>.</p>
/// </li>
/// <li>
/// <p>Create and update the <code>Rules</code> that you want to include in the <code>WebACL</code>. For more information, see
/// <a>CreateRule</a> and <a>UpdateRule</a>.</p>
/// </li>
/// <li>
/// <p>Create a <code>WebACL</code>. See <a>CreateWebACL</a>.</p>
/// </li>
/// <li>
/// <p>Use <code>GetChangeToken</code> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateWebACL</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateWebACL</code> request to specify the <code>Rules</code>
/// that you want to include in the <code>WebACL</code>, to specify the default action,
/// and to associate the <code>WebACL</code> with a CloudFront distribution. </p>
/// <p>The <code>ActivatedRule</code> can be a rule group. If you specify a rule group
/// as your
/// <code>ActivatedRule</code>
/// ,
/// you can exclude specific rules from that rule group.</p>
/// <p>If you already have a rule group associated with a web ACL and want to submit
/// an <code>UpdateWebACL</code> request to exclude certain rules from that rule group,
/// you must first remove the rule group from the web ACL, the re-insert it again,
/// specifying the excluded rules.
/// For details,
/// see
/// <a>ActivatedRule$ExcludedRules</a>
/// .
/// </p>
/// </li>
/// </ol>
/// <p>Be aware that if you try to add a RATE_BASED rule to a web ACL without setting the rule type when first creating the rule, the  <a>UpdateWebACL</a> request will fail because the request tries to add a REGULAR rule (the default rule type) with the specified ID, which does not exist.     </p>      
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateWebACL {
    _private: (),
}
impl UpdateWebACL {
    /// Creates a new builder-style object to manufacture [`UpdateWebAclInput`](crate::input::UpdateWebAclInput)
    pub fn builder() -> crate::input::update_web_acl_input::Builder {
        crate::input::update_web_acl_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateWebACL {
    type Output =
        std::result::Result<crate::output::UpdateWebAclOutput, crate::error::UpdateWebACLError>;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_web_acl_error(response)
        } else {
            crate::operation_deser::parse_update_web_acl_response(response)
        }
    }
}

/// <note>
/// <p>This is <b>AWS WAF Classic</b> documentation. For
/// more information, see <a href="https://docs.aws.amazon.com/waf/latest/developerguide/classic-waf-chapter.html">AWS
/// WAF Classic</a> in the developer guide.</p>
/// <p>
/// <b>For the latest version of AWS
/// WAF</b>, use the AWS WAFV2 API and see the <a href="https://docs.aws.amazon.com/waf/latest/developerguide/waf-chapter.html">AWS WAF Developer Guide</a>. With the latest version, AWS WAF has a single set of endpoints for regional and global use. </p>
/// </note>
/// <p>Inserts or deletes <a>XssMatchTuple</a> objects (filters) in an <a>XssMatchSet</a>.
/// For each <code>XssMatchTuple</code> object, you specify the following values:</p>
/// <ul>
/// <li>
/// <p>
/// <code>Action</code>: Whether to insert the object into or delete the object from the
/// array. To change an
/// <code>XssMatchTuple</code>, you delete the existing object and add a new
/// one.</p>
/// </li>
/// <li>
/// <p>
/// <code>FieldToMatch</code>: The part of web requests that you want AWS WAF to inspect and, if you want AWS WAF to inspect a header or custom query parameter,
/// the name of the header or parameter.</p>
/// </li>
/// <li>
/// <p>
/// <code>TextTransformation</code>: Which text transformation, if any, to perform on the web request before
/// inspecting the request for cross-site scripting attacks.</p>
/// <p>You can only specify a single type of TextTransformation.</p>
/// </li>
/// </ul>
/// <p>You use <code>XssMatchSet</code> objects to specify which CloudFront requests
/// that
/// you want to allow, block, or count. For example, if you're receiving
/// requests that contain cross-site scripting attacks in the request body and you want to
/// block the requests, you can create an <code>XssMatchSet</code> with the applicable
/// settings, and then configure AWS WAF to block the requests. </p>    
/// <p>To create and configure an <code>XssMatchSet</code>, perform the following steps:</p>
/// <ol>
/// <li>
/// <p>Submit a <a>CreateXssMatchSet</a> request.</p>
/// </li>
/// <li>
/// <p>Use <a>GetChangeToken</a> to get the change token that you provide in the <code>ChangeToken</code> parameter of an
/// <a>UpdateIPSet</a> request.</p>
/// </li>
/// <li>
/// <p>Submit an <code>UpdateXssMatchSet</code> request to specify the parts of web requests that you want AWS WAF to
/// inspect for cross-site scripting attacks.</p>
/// </li>
/// </ol>
/// <p>For more information about how to use the AWS WAF API to allow or block HTTP requests, see the
/// <a href="https://docs.aws.amazon.com/waf/latest/developerguide/">AWS WAF Developer Guide</a>.</p>
#[derive(std::default::Default, std::clone::Clone, std::fmt::Debug)]
pub struct UpdateXssMatchSet {
    _private: (),
}
impl UpdateXssMatchSet {
    /// Creates a new builder-style object to manufacture [`UpdateXssMatchSetInput`](crate::input::UpdateXssMatchSetInput)
    pub fn builder() -> crate::input::update_xss_match_set_input::Builder {
        crate::input::update_xss_match_set_input::Builder::default()
    }
    pub fn new() -> Self {
        Self { _private: () }
    }
}
impl smithy_http::response::ParseStrictResponse for UpdateXssMatchSet {
    type Output = std::result::Result<
        crate::output::UpdateXssMatchSetOutput,
        crate::error::UpdateXssMatchSetError,
    >;
    fn parse(&self, response: &http::Response<bytes::Bytes>) -> Self::Output {
        if !response.status().is_success() && response.status().as_u16() != 200 {
            crate::operation_deser::parse_update_xss_match_set_error(response)
        } else {
            crate::operation_deser::parse_update_xss_match_set_response(response)
        }
    }
}
